
; Listing8f.s	Eine FADE-Routine (dh Ein-und Ausblenden)
;				von und nach JEDER FARBE
; Drcken Sie abwechselnd die linke und rechte Taste, um die verschiedenen Optionen 
; bergnge anzuzeigen

	SECTION	Fade1,CODE

;	Include	"DaWorkBench.s"	; entferne das; vor dem Speichern mit "WO"

*****************************************************************************
	include	"/Sources/startup1.s"	; speichern copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	EQU	%1000001110000000	; nur copper und bitplane DMA
;			 -----a-bcdefghij

;	a: Blitter Nasty
;	b: Bitplane DMA	   (Wenn es nicht gesetzt ist, verschwinden auch die Sprites)
;	c: Copper DMA
;	d: Blitter DMA
;	e: Sprite DMA
;	f: Disk DMA
;	g-j: Audio 3-0 DMA

START:
	MOVE.L	#Logo1,d0			; Adresse der Bitplane
	LEA	BPLPOINTERS,A1			; Bitplanepointer in der copperlist
	MOVEQ	#4-1,D1				; Anzahl der Bitplanes (hier sind es 4)
POINTBP:
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	swap	d0
	ADD.L	#40*84,d0			; + Lnge einer Bitplane (84 Zeilen hoch hier)
	addq.w	#8,a1
	dbra	d1,POINTBP

	MOVE.W	#DMASET,$96(a5)		; DMACON - Aktivieren Sie Bitplane, copper
								; und Sprites.
	move.l	#COPPERLIST,$80(a5)	; Zeiger COP
	move.w	d0,$88(a5)			; Start COP
	move.w	#0,$1fc(a5)			; AGA deaktivieren
	move.w	#$c00,$106(a5)		; AGA deaktivieren
	move.w	#$11,$10c(a5)		; AGA deaktivieren

mouse1:
	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	mouse1

;	********** erstes Fade (Einblenden): von SCHWARZ zu Farben *********

mouse2:
	CMP.b	#$ff,$dff006		; Zeile 255
	bne.s	mouse2
Aspetta1:
	CMP.b	#$ff,$dff006		; Zeile 255
	beq.s	Aspetta1

	lea	Cstart1-2,a1			; Start Farbtabelle
	lea	Cend1-2,a2				; Ende Farbtabelle
	bsr.w	dofade				; Fade!!!


	btst	#2,$dff016			; rechte Maustaste gedrckt?
	bne.s	mouse2

	clr.w	FaseDelFade			; die Bildnummer zurcksetzen

;	********** zweites Fade (Ausblenden): von Farben zu SCHWARZ *********

mouse3:
	CMP.b	#$ff,$dff006		; Zeile 255
	bne.s	mouse3
Aspetta2:
	CMP.b	#$ff,$dff006		; Zeile 255
	beq.s	Aspetta2

	lea	Cstart2-2,a1			; Start Farbtabelle
	lea	Cend2-2,a2				; Ende Farbtabelle
	bsr.w	dofade				; Fade!!!


	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	mouse3

	clr.w	FaseDelFade			; die Bildnummer zurcksetzen
		
;	********** drittes Fade (Einblenden): von WEISS zu Farben *********

mouse4:	
	CMP.b	#$ff,$dff006		; Zeile 255
	bne.s	mouse4
Aspetta3:
	CMP.b	#$ff,$dff006		; Zeile 255
	beq.s	Aspetta3

	lea	Cstart3-2,a1			; Start Farbtabelle
	lea	Cend3-2,a2				; Ende Farbtabelle
	bsr.w	dofade				; Fade!!!


	btst	#2,$dff016			; rechte Maustaste gedrckt?
	bne.s	mouse4

	clr.w	FaseDelFade			; die Bildnummer zurcksetzen

;	********** viertes Fade: von FARBEN zu anderen verschiedenen Farben! *

mouse5:
	CMP.b	#$ff,$dff006		; Zeile 255
	bne.s	mouse5
Aspetta4:
	CMP.b	#$ff,$dff006		; Zeile 255
	beq.s	Aspetta4

	lea	Cstart4-2,a1			; Start Farbtabelle
	lea	Cend4-2,a2				; Ende Farbtabelle
	bsr.w	dofade				; Fade!!!


	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	mouse5

	clr.w	FaseDelFade			; die Bildnummer zurcksetzen

;	********** fnftes Fade: von FARBEN zu anderen verschiedenen Farben! *

mouse6:
	CMP.b	#$ff,$dff006		; Zeile 255
	bne.s	mouse6
Aspetta5:
	CMP.b	#$ff,$dff006		; Zeile 255
	beq.s	Aspetta5

	lea	Cstart5-2,a1			; Start Farbtabelle
	lea	Cend5-2,a2				; Ende Farbtabelle
	bsr.w	dofade				; Fade!!!

	btst	#2,$dff016			; rechte Maustaste gedrckt?
	bne.s	mouse6

	rts


*****************************************************************************
*	Routine zum Ein- und Ausblenden in und aus einer beliebigen Farbe!		*
* Eingabe:																	*
*																			*
* d6 = Anzahl Farben-1														*
* a1 = Adresse Tabelle 1 mit den Farben des Bildes (Quelle)					*
* a2 = Adresse Tabelle 2 mit den Farben des Bildes (Ziel)					*
* a0 = Adresse der ersten Farbe in der copperlist							*
* Label FaseDelFade als d0 fr vorherige Routinen verwendet,				*
* = Moment der berblendung, Multiplikator, in diesem Fall ist es jedoch    *
* notwendig, ihn zurckzusetzen. Einfach, um eine neue berblendung		    *
* zu starten																*
* Der Ablauf der Routine ist komplexer als die vorherigen und				*
* eigentlich wei ich gar nicht mehr, wie genau das funktioniert.			*
* Lesen Sie meine alten Kommentare, aber Hauptsache Sie wissen, wie man es  *
* benutzt																	*
*****************************************************************************

;	           .--._.--. 
;	          ( O     O ) 
;	          /   . .   \ 
;	         .`._______.'. 
;	        /(    \_/    )\ 
;	      _/  \  \   /  /  \_ 
;	   .~   `  \  \ /  /  '   ~. 
;	  {    -.   \  V  /   .-    } 
;	_ _`.    \  |  |  |  /    .'_ _ 
;	>_       _} |  |  | {_       _< 
;	 /. - ~ ,_-'  .^.  `-_, ~ - .\ 
;	         '-'|/   \|`-` 

dofade:
	cmp.w	#17,FaseDelFade		; Haben wir die letzte Phase erreicht? (16)?
	beq.s	FadeFinito
	lea	CopColors+2,a0			; Farben in der copperlist
	move.w	#15-1,d6			; Anzahl Farben 
	bsr.w	fade2				; Aufruf Fading!
FadeFinito:
	rts

; benutzt d0-d6/a0-a2

fade2:
f2main:
	addq.w	#4,a0				; gehe zum nchsten Farbregister in der copperliste
	addq.w	#2,a1				; gehe zur nchsten Farbe der Quell-Farbtabelle
	addq.w	#2,a2				; das Gleiche gilt fr die Ziel-Farbtabelle
	move.w	(a0),d0				; Farbe von copperlist in d0
	move.w	(a2),d1				; Farbe Zieltabelle in d1
	cmp.w	d0,d1				; sind sie die gleichen?
	beq.w	ProssimoColore		; wenn ja, gehe zur nchsten Farbe
	move.w	FaseDelFade(PC),d4	; Phase der berblendung in d4 (0-16)
	clr.w	ColoreFinale		; die endgltige Farbe zurcksetzen

; BLAU

	move.w	(a1),d0				; aktuelle Farbe der Quell-Farbtabelle in d0
	move.w	(a2),d2				; Farbe der Ziel-Farbtabelle in d2
	and.l	#$00f,d0			; nur das BLAU von der Farbe der Quelltabelle auswhlen 
	and.l	#$00f,d2			; Farbe der Ziel-Farbtabelle
	cmp.w	d2,d0				; sind BLAU Quelle und Ziel gleich?
	bhi.b	SottraiD2			; wenn d2>d0, FadCh1a
	beq.b	SottraiD2			; wenn sie gleich sind, subtrahiere d2
	sub.w	d0,d2				; wenn d2<d0, sub d0 bis d2!
	bra.b	SottFatto
SottraiD2:
	sub.w	d2,d0				; sonst sub d2 von d0!
	bra.b	SottFatto2

SottFatto:
	move.w	d2,d0
SottFatto2:
	moveq	#16,d1
	bsr.w	dodivu
	and.w	#$00f,d1			; nur BLAU auswhlen
	move.w	(a1),d0				; aktuelle Farbe der Quell-Farbtabelle in d0
	move.w	(a2),d2				; Farbe der Ziel-Farbtabelle in d2
	and.w	#$00f,d0			; nur das BLAU von der Farbe der Quelltabelle auswhlen
	and.w	#$00f,d2			; Farbe der Ziel-Farbtabelle
	cmp.w	d0,d2				; sind BLAU Quelle und Ziel gleich?
	bhi.b	SommaD1				; wenn d0>d2, Summe d1 + d0
	beq.b	OkBlu				; wenn sie gleich sind, ok
	sub.w	d1,d0				; d0=d0-d1
	bra.b	OkBlu
SommaD1:
	add.w	d1,d0				; d0=d0+d1
OkBlu:
	move.w	d0,ColoreFinale		; das endgltige BLAU speichern

; GRN

	move.w	(a1),d0				; aktuelle Farbe der Quell-Farbtabelle in d0
	move.w	(a2),d2				; Farbe der Ziel-Farbtabelle in d2
	and.l	#$0f0,d0			; nur das GRN von der Farbe der Quelltabelle auswhlen
	and.l	#$0f0,d2			; Farbe der Ziel-Farbtabelle
	cmp.w	d2,d0				; sind GRN Quelle und Ziel gleich?
	bhi.b	SottraiD2v			; wenn d2>d0, FadCh1a
	beq.b	SottraiD2v			; wenn sie gleich sind, subtrahiere d2
	sub.w	d0,d2				; wenn d2<d0, subba d0 bis d2!
	bra.b	SottFattov
SottraiD2v:
	sub.w	d2,d0				; sonst sub d2 von d0!
	bra.b	SottFatto2v

SottFattov:
	move.w	d2,d0
SottFatto2v:
	moveq	#16,d1
	bsr.w	dodivu
	and.w	#$0f0,d1			; nur GRN auswhlen
	move.w	(a1),d0				; aktuelle Farbe der Quell-Farbtabelle in d0
	move.w	(a2),d2				; Farbe der Ziel-Farbtabelle in d2
	and.w	#$0f0,d0			; nur das GRN von der Farbe der Quelltabelle auswhlen
	and.w	#$0f0,d2			; Farbe der Ziel-Farbtabelle
	cmp.w	d0,d2				; sind GRN Quelle und Ziel gleich?
	bhi.b	SommaD1v			; wenn d0>d2, Summe d1 + d0
	beq.b	OkVERDE				; wenn sie gleich sind, ok
	sub.w	d1,d0				; d0=d0-d1
	bra.b	OkVERDE
SommaD1v:
	add.w	d1,d0				; d0=d0+d1
OkVERDE:
	or.w	d0,ColoreFinale		; mit dem OR die grne Komponente verbinden

; ROT

	move.w	(a1),d0				; aktuelle Farbe der Quell-Farbtabelle in d0
	move.w	(a2),d2				; Farbe der Ziel-Farbtabelle in d2
	and.l	#$f00,d0			; Whlen Sie nur das ROT von der Farbe der Quelltabelle
	and.l	#$f00,d2			; Farbe der ZielFarbtabelle
	cmp.w	d2,d0				; sind ROT Quelle und Ziel gleich?
	bhi.b	SottraiD2r			; wenn d2>d0, FadCh1a
	beq.b	SottraiD2r			; wenn sie gleich sind, subtrahiere d2
	sub.w	d0,d2				; wenn d2<d0, sub d0 bis d2!
	bra.b	SottFattor
SottraiD2r:
	sub.w	d2,d0				; sonst sub d2 bis d0!
	bra.b	SottFatto2r

SottFattor:
	move.w	d2,d0
SottFatto2r:
	moveq	#16,d1
	bsr.w	dodivu
	and.w	#$f00,d1			; nur ROT auswhlen
	move.w	(a1),d0				; aktuelle Farbe der Quell-Farbtabelle in d0
	move.w	(a2),d2				; Farbe der Ziel-Farbtabelle in d2
	and.w	#$f00,d0			; nur das ROT von der Farbe der Quelltabelle auswhlen
	and.w	#$f00,d2			; Farbe der Ziel-Farbtabelle
	cmp.w	d0,d2				; sind ROT Quelle und Ziel gleich?
	bhi.b	SommaD1r			; wenn d0>d2, Summe d1 + d0
	beq.b	OkROSSO				; wenn sie gleich sind, ok
	sub.w	d1,d0				; d0=d0-d1
	bra.b	OkROSSO
SommaD1r:
	add.w	d1,d0				; d0=d0+d1
OkROSSO:
	or.w	d0,ColoreFinale		; mit dem OR die rote Komponente verbinden

; die Farbe in der copperliste eingeben!

	move.w	ColoreFinale(PC),(a0)	; und die endgltige Farbe in die copperliste legen!

ProssimoColore:
	dbra	d6,f2main			; Wiederholen fr jede Farbe

	addq.w	#1,FaseDelFade		; den nchsten Schritt vorbereiten
nocrs:
	rts

***
* Eingang -> D0 = Anzahl
*			 D1 = Nenner	(16)
*			 D4 = * Multiplikationsfaktor
*
* Ausgang -> D1 = Ergebnis
***

DoDivu:
	divu.w	d1,d0				; Division durch 16, nicht optimierbar mit lsr
	move.l	d0,d1
	swap	d1
	move.l	#$31000,d2			; $10003 (65539) divu 16
	moveq	#0,d3
	move.w	d1,d3
	mulu.w	d3,d2
	move.w	d2,d1
	and.l	#$ffff,d1
	mulu.w	d4,d1				; multiplizieren mit der Fade-Phase
	swap	d1
	mulu.w	d4,d0				; multiplizieren mit der Fade-Phase
	add.w	d0,d1
	and.l	#$ffff,d1
	rts

FaseDelFade:					; aktuelle Phase der berblendung (0-16)
	dc.w	0

;	Die endgltige Farbe wird jedes Mal in diesem Label gespeichert

ColoreFinale:
	dc.w	0

; ---

Cstart1:
	dcb.w	15,0									; Lass uns von Schwarz ausgehen
Cend1:
	dc.w $fff,$200,$310,$410,$620,$841,$a73			; und wir kommen zu den Farben
	dc.w $b95,$db6,$dc7,$111,$222,$334,$99b,$446
;=----------

Cstart2:
	dc.w $fff,$200,$310,$410,$620,$841,$a73			; Beginnen wir mit Farben
	dc.w $b95,$db6,$dc7,$111,$222,$334,$99b,$446
Cend2:
	dcb.w	15,0									; und wir landen in schwarz
;=----------

Cstart3:
	dcb.w	15,$FFF									; Fangen wir mit WEISS an
Cend3:
	dc.w $fff,$200,$310,$410,$620,$841,$a73			; und wir kommen zu den Farben
	dc.w $b95,$db6,$dc7,$111,$222,$334,$99b,$446
;=----------

Cstart4:
	dc.w $fff,$200,$310,$410,$620,$841,$a73			; Beginnen wir mit Farben
	dc.w $b95,$db6,$dc7,$111,$222,$334,$99b,$446
Cend4:
	dc.w $fff,$020,$031,$041,$062,$184,$3a7			; und wir bekommen andere
	dc.w $5b9,$6db,$7dc,$111,$222,$433,$b99,$644	; Farben! (grner Ton)
;=----------

Cstart5:
	dc.w $fff,$020,$031,$041,$062,$184,$3a7			; Beginnen wir mit anderen
	dc.w $5b9,$6db,$7dc,$111,$222,$433,$b99,$644	; Farben! (grner Ton)
Cend5:
	dc.w $fff,$002,$013,$014,$026,$148,$37a			; zu noch anderen Farben!
	dc.w $59b,$6bd,$7cd,$111,$222,$334,$99b,$446	; (blauer Ton)
;=----------


; die $180, color0, sind $000, also nicht ndern! Die Tabelle beginnt mit color1

TabColoriPic:
	dc.w $fff,$200,$310,$410,$620,$841,$a73
	dc.w $b95,$db6,$dc7,$111,$222,$334,$99b,$446


*****************************************************************************
;			Copper List
*****************************************************************************
	section	copper,data_c		; Chip data

Copperlist:
	dc.w	$8E,$2c81			; DiwStrt - window start
	dc.w	$90,$2cc1			; DiwStop - window stop
	dc.w	$92,$38				; DdfStart - data fetch start
	dc.w	$94,$d0				; DdfStop - data fetch stop
	dc.w	$102,0				; BplCon1 - scroll register
	dc.w	$104,0				; BplCon2 - priority register
	dc.w	$108,0				; Bpl1Mod - modulo pl. ungerade
	dc.w	$10a,0				; Bpl2Mod - modulo pl. gerade

			    ; 5432109876543210
	dc.w	$100,%0100001000000000	; BPLCON0 - 4 planes lowres (16 Farben)

; Bitplane pointers

BPLPOINTERS:
	dc.w	$e0,$0000,$e2,$0000	; erste bitplane
	dc.w	$e4,$0000,$e6,$0000	; zweite bitplane
	dc.w	$e8,$0000,$ea,$0000	; dritte bitplane
	dc.w	$ec,$0000,$ee,$0000	; vierte bitplane

; Die ersten 16 Farben sind fr das LOGO

CopColors:
	dc.w	$180,0,$182,0,$184,0,$186,0
	dc.w	$188,0,$18a,0,$18c,0,$18e,0
	dc.w	$190,0,$192,0,$194,0,$196,0
	dc.w	$198,0,$19a,0,$19c,0,$19e,0

;	Lassen Sie uns ein paar Nuancen fr die Szenografie setzen...

	dc.w	$8007,$fffe			; Wait - $2c+84=$80
	dc.w	$100,$200			; bplcon0 - no bitplanes
	dc.w	$180,$003			; color0
	dc.w	$8207,$fffe			; wait
	dc.w	$180,$005			; color0
	dc.w	$8507,$fffe			; wait
	dc.w	$180,$007			; color0
	dc.w	$8a07,$fffe			; wait
	dc.w	$180,$009			; color0
	dc.w	$9207,$fffe			; wait
	dc.w	$180,$00b			; color0
	dc.w	$9e07,$fffe			; wait
	dc.w	$180,$999			; color0
	dc.w	$a007,$fffe			; wait
	dc.w	$180,$666			; color0
	dc.w	$a207,$fffe			; wait
	dc.w	$180,$222			; color0
	dc.w	$a407,$fffe			; wait
	dc.w	$180,$001			; color0
	dc.l	$ffff,$fffe			; Ende copperlist


*****************************************************************************
;				DESIGN
*****************************************************************************

	section	gfxstuff,data_c

; Zeichnen von 320 Pixel breiten, 84 hohen 4-Bit-Ebenen (16 Farben).

Logo1:
	incbin	"/Sources/logo320x84x16c.raw"


	end

Hier ist eine Routine, die Farben nach Belieben "transformiert". Das
Funktionsprinzip ist daher komplexer als bei einer normalen berblendung.
Verstehen Sie einfach, wie sie es benutzen knnen. Wenn Sie Ihr Gehirn braten
wollen, habe ich jedoch Kommentare abgegeben.

