
; Listing23e.s		hires, interlace, overscan - max screensize
;					(736x566) experimentell ermittelt

	SECTION	Interlace,CODE

;	Include	"DaWorkBench.s"		; entferne das; vor dem Speichern mit "WO"

*****************************************************************************
	include "/Sources/startup2.s"	; speichern copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	EQU	%1000001110000000	; nur copper und bitplane DMA

WaitDisk	EQU	30

scr_bytes	= 92				; Anzahl der Bytes fr jede horizontale Zeile.
								; Daraus berechnen wir die Bildschirmbreite,
								; Multiplizieren von Bytes mit 8: normaler Bildschirm 320/8 = 40
								; z.B. fr einen 336 Pixel breiten Bildschirm 336/8 = 42
								; Beispielbreiten:
								; 264 pixel = 33 / 272 pixel = 34 / 280 pixel = 35
								; 360 pixel = 45 / 368 pixel = 46 / 376 pixel = 47
								; ... 640 pixel = 80 / 648 pixel = 81 ...
								
scr_h		= 566				; Bildschirmhhe in Zeilen
scr_x		= $5c				; Startbildschirm, XX-Position (normal $xx81) (129)
scr_y		= $1a				; Startbildschirm, YY-Position (normal $2cxx) (44)

scr_res		= 2					; 2 = HighRes (640*xxx) / 1 = LowRes (320*xxx)
scr_lace	= 1					; 0 = non interlace (xxx*256) / 1 = interlace (xxx*512)
ham			= 0					; 0 = non ham / 1 = ham
scr_bpl		= 1					; Anzahl Bitplanes

; Parameter automatisch berechnet

scr_w		= scr_bytes*8		; Bildschirmbreite
scr_size	= scr_bytes*scr_h	; Gre in Bytes des Bildschirms
BPLC0	= ((scr_res&2)<<14)+(scr_bpl<<12)+$200+(scr_lace<<2)+(ham<<11)
DIWS	= (scr_y<<8)+scr_x
DIWSt	= ((scr_y+scr_h/(scr_lace+1))&255)<<8+(scr_x+scr_w/scr_res)&255
DDFS	= (scr_x-(16/scr_res+1))/2
DDFSt	= DDFS+(8/scr_res)*(scr_bytes/2-scr_res)


START:
	MOVE.L	#BITPLANE,d0		; wohin pointen
	LEA	BPLPOINTERS1,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	

	MOVE.L	#BITPLANE+scr_bytes,d0		; wohin pointen
	LEA	BPLPOINTERS2,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	
	MOVE.L	#Cop_lace2,d0		; wohin pointen
	LEA	COP_Pointer1,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.L	#Cop_lace1,d0		; wohin pointen
	LEA	COP_Pointer2,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.W	#DMASET,$96(a5)		; DMACON - aktivieren bitplane, copper
	move.l	#Copperlist,$dff084 ; COPL2
	move.w	#0,$1fc(a5)			; AGA deaktivieren
	move.w	#$c00,$106(a5)		; AGA deaktivieren
	move.w	#$11,$10c(a5)		; AGA deaktivieren

	bsr	pic_frame				; Bilderrahmen (Aussengrenzen) hinzufgen
	bsr LACEINT					; LOF-Bit testen und Copperpointer eintragen

mouse:
	MOVE.L	#$1ff00,d1			; Bit zur Auswahl durch UND
	MOVE.L	#$01000,d2			; warte auf Zeile $010
Waity1:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; warte auf Zeile $010
	BNE.S	Waity1
Waity2:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; warte auf Zeile $010
	Beq.S	Waity2
	
	;bsr.w	effekt				; hier irgendeinen Effekt hinzufgen

	btst	#6,$bfe001			; Maus gedrckt?
	bne.s	mouse

	rts

******************************************************************************
; INTERLACE ROUTINE - Test Bit LOF (Long Frame) um zu wissen, ob Sie
; gerade oder ungerade Zeilen anzeigen und entsprechend wechseln mssen.
******************************************************************************
LACEINT:
	btst.b	#15-8,4(A5)			; VPOSR LOF bit?
	Beq.s	Faidispari			; wenn ja, zeigen Sie auf ungerade Zeilen
	
								; Starten der Ansicht von den geraden Zeilen!
								; zweitens: gerade Zeilen werden angezeigt!
	move.l	#Cop_lace1,$dff080	; unsere COP
	move.w	d0,$dff088			; START COP
	rts

FaiDispari:
	move.l	#Cop_lace2,$dff080	; unsere COP
	move.w	d0,$dff088			; START COP
	rts

******************************************************************************
; Bildrahmen
******************************************************************************

pic_frame:
	lea BITPLANE,a0					; erste Zeile
	lea BITPLANE_E-scr_bytes,a1		; letzte Zeile
	move.b #$FF,d0					; die Bitplane mit Linien fllen	
	move.w #scr_bytes-1,d1			; Anzahl Bytes (Bildschirmbreite)
pf1:
	move.b d0,(a0)+					; obere Linie
	move.b d0,(a1)+					; untere Linie
	dbf d1,pf1

	lea BITPLANE+scr_bytes,a0				; mit der zweiten Zeile beginnen links
	lea BITPLANE+scr_bytes+scr_bytes-1,a1	; mit der zweiten Zeile beginnen rechts
	move.b #$80,d0					; senkrechte Linie links
	move.b #$01,d1					; senkrechte Linie rechts
	move.w #scr_h-2-1,d2			; Hhe-2 Zeilen
pf2:
	move.b d0,(a0)
	move.b d1,(a1)
	lea scr_bytes(a0),a0			; nchste Zeile (scr_bytes=80)
	lea scr_bytes(a1),a1			; nchste Zeile (scr_bytes=80)
	dbf d2,pf2
	
	rts

******************************************************************************

	SECTION	GRAPHIC,DATA_C
	
Cop_lace1:
BPLPOINTERS1:
	dc.w	$e0,0,$e2,0		; erste Bitplane
COP_Pointer1:
	dc.w 	$80,$0,$82,$0	; auf Cop_lace2 setzen 
	dc.w 	$8a,$0			; COPJMP2
	dc.w 	$ffff,$fffe		; only symbolic	

Cop_lace2:
BPLPOINTERS2:
	dc.w	$e0,0,$e2,0		; erste Bitplane+80
COP_Pointer2:
	dc.w 	$80,$0,$82,$0	; auf Cop_lace1 setzen 

Copperlist:	
	dc.w	$8e,DIWS		; DiwStrt
	dc.w	$90,DIWSt		; DiwStop
	dc.w	$92,DDFS		; DdfStart
	dc.w	$94,DDFSt		; DdfStop

	dc.w	$102,$33			; BplCon1	etwas nach rechts verschieben
	dc.w	$104,0				; BplCon2
	dc.w	$108,scr_bytes		; Bpl1Mod \ INTERLACE: modulo = Lnge Zeile!
	dc.w	$10a,scr_bytes		; Bpl2Mod / um sie zu berspringen (die geraden)

				; 5432109876543210
;	dc.w	$100,%1001001000000100	; 1 bitplane, HIRES LACE 640x512
;								; Beachten Sie das Bit 2 Set fr LACE!!

	dc.w	$100,BPLC0			; BplCon0 -> lassen Sie es uns automatisch berechnen!
	
	dc.w	$180,$226			; color0 - Hintergrund
	dc.w	$182,$0b0			; color1 - plane 1 Position normal, und
								; der "klebende" Teil an der Spitze.

	dc.w	$ffff,$fffe			; Ende copperlist


******************************************************************************

	SECTION	MIOPLANE,BSS_C

BITPLANE:
	ds.b	scr_bytes*scr_h		; 92*566 eine bitplane Hires int. 736x566
BITPLANE_E:

	end

Erklrung:

WinUAE bietet unter Display/ Overscan folgende Einstellmglichkeiten:
-TV (narrow)
-TV (standard)
-TV (wide)
-Overscan					; zeigt rechts den Rand
-Overscan+					; zeigt links den Rand
-Extreme
-Ultra extreme debug
-Ultra extreme debug (HV)
-Ultra extreme debug (C)

Das Bild zeigt einen schmalen Rahmen um den Screen, der in die usseren 
Pixelreihen und -spalten in die Bitplane gezeichnet wurden. Der Screen wurde 
mit dem BPLCON1 etwas nach rechts verschoben.

;------------------------------------------------------------------------------
mein Ergebnis: (736x) - 46*16=736	(mod 92)

scr_bytes = 92
scr_x = $59
DIWSTRT: $2c59 DIWSTOP: $2cc9 DDFSTRT: $0028 DDFSTOP: $00d8

Es sind gute und richtige Werte. Es gibt keine Probleme. (DDFSTOP_ex =D8)
Es ist keine Modulo Korrektur notwendig.

;------------------------------------------------------------------------------
ross: (736x) - 46*16=736	(mod 92)

scr_bytes = 92
scr_x = $5c
DIWSTRT: $1a5c DIWSTOP: $35cc DDFSTRT: $0028 DDFSTOP: $00d8

The first pixel after the blank is with DDFSTRT=$28 and BPLCON1=$33.
Of course changing BPLCON1 you can 'move' the covered part and use some of the
unused space atthe extreme right (not completely, but in any case it is 
usually off-screen).

