		
; Listing24c2.s - https://eab.abime.net/showthread.php?t=109211
; Copperlinien mit Skip, ein "Artefakt" am Ende der Zeile berdecken
; Ursprung jobbo

	SECTION	R'nR,code
	
	incdir "/Sources/include/"	
	include	"MVstartup.s"		; Startup Code

			;5432109876543210
DMASET	EQU	%1000001110000000	; copper DMA


Start:
	MOVE.L	#BITPLANE,d0		; Adresse der Bitplane
	LEA	BPLPOINTERS,A1			; Bitplanepointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	
	move	#DMASET,dmacon(a5)
	move.l	#COPPERLIST,cop1lc(a5)
	;move	d0,copjmp1(a5)

	move.l	#copperloop1,d0
	move	d0,cpptr1+6
	swap	d0
	move	d0,cpptr1+2

	move.l	#copperloop2,d0
	move	d0,cpptr2+6
	swap	d0
	move	d0,cpptr2+2

mouse:
	btst	#6,$bfe001			; Maus gedrckt?
	bne.s	mouse

	rts


	SECTION	MY_COPPER,CODE_C

COPPERLIST:
	dc.w	$8e,$1aff		; DiwStrt
	dc.w	$90,$38d1		; DiwStop
	dc.w	$92,$d0			; DdfStart
	dc.w	$94,$d8			; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod

				; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres

BPLPOINTERS:
	dc.w	$e0,0,$e2,0		; erste Bitplane

	dc.w	$180,$000		; color0	; Hintergrund Schwarz
	dc.w	$182,$000		; color1	; Farbe 1 der Bitplane, die
							; in diesem Fall leer ist,
							; und deswegen nicht erscheint
    dc.w	$1A2,$000		; Color17, oder COLOR1 des Sprite0 - schwarz
	dc.w	$1A4,$0F0		; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0		; Color19, oder COLOR3 des Sprite0 - GELB
	
	dc.w	$1a01,$fffe		; Warte auf Zeile $2b um rechtzeitig das Sprite vorzubereiten
	dc.w	$140,$00e0		; SPR0POS - Horizontale Position
	dc.w	$142,$0000		; SPR0CTL
	dc.w	$146,$0000		; SPR0DATB
	dc.w	$144,$07ff		; SPR0DATA - aktiviert Sprite

copperllines	
	dc.w	$2c01, $fffe
	dc.w	$0180, $0f00, $00e1, $80fe
	dc.w	$0180, $00f0, $00e1, $80fe
	dc.w	$0180, $000f, $00e1, $80fe
	dc.w	$0180, $0f00, $00e1, $80fe
	dc.w	$0180, $00f0, $00e1, $80fe
	dc.w	$0180, $000f, $00e1, $80fe
	dc.w	$0180, $0f00, $00e1, $80fe
	dc.w	$0180, $00f0, $00e1, $80fe
	dc.w	$0180, $000f, $00e1, $80fe
	dc.w	$0180, $0f00, $00e1, $80fe	
	dc.w	$0180, $0000
		
	dc.w	$8007,$fffe
cpptr1
	dc.w	$084,0
	dc.w	$086,0

copperloop1	
	dc.w	$8007,$9ffe	
	dc.w	$0180, $0f00, $80e1, $80fe
	dc.w	$0180, $00f0, $80e1, $80fe
	dc.w	$0180, $000f, $80e1, $80fe

	dc.w	$9007,$9ffe	 
	dc.w	$0180, $0f00, $80e1, $80fe
	dc.w	$0180, $00f0, $80e1, $80fe
	dc.w	$0180, $000f, $80e1, $80fe

	dc.w	$9fd7,$9ffe	
	dc.w	$ffdd,$ffff		
	dc.w	$8a,0	
		
cpptr2
	dc.w	$084,0
	dc.w	$086,0
	
copperloop2		
	dc.w	$0007,$9ffe
	dc.w	$180,$000

	dc.w	$1007, $9ffe	 
	dc.w	$0180, $0f00, $00e1, $80fe
	dc.w	$0180, $00f0, $00e1, $80fe
	dc.w	$0180, $000f, $00e1, $80fe
	dc.w	$0180, $0f00, $00e1, $80fe
	dc.w	$0180, $00f0, $00e1, $80fe
	dc.w	$0180, $000f, $00e1, $80fe
	dc.w	$0180, $0f00, $00e1, $80fe
	dc.w	$0180, $00f0, $00e1, $80fe
	dc.w	$0180, $000f, $00e1, $80fe
	dc.w	$0180, $0f00, $00e1, $80fe	
	dc.w	$0180, $0000

	dc.w	$1fe1,$9ffe

	dc.w	$2007,$ffff
	dc.w	$8a,0
	
	dc.w	$ffff,$fffe


	SECTION LEEREPLANE,BSS_C	; Eine auf 0 gesetzte Bitplane, wir
							; mssen es verwenden, denn ohne Bitplane
							; ist es nicht mglich, die Sprites
							; zu aktivieren
BITPLANE:
	ds.b	40*256			; Bitplane auf 0 Lowres

	END


Erklrung:

Wenn man mit dem Copper ber die gesamte Bildschirmbreite Copperlinien haben 
mchte und diese mit dem Skip, also durch Copperschleifen erstellt, steht man
augenscheinlich vor dem Problem, dass am Ende der Zeile eine Farbabstufung
erscheint.

Um diese Artefakt loszuwerden, bietet es sich an, es durch Bitplanedaten oder
durch ein Sprite zu berdecken.

Um das Artefakt zu sehen: ;dc.w	$140,$00e0		; SPR0POS - Horizontale Position
Um das Artefakt zu berdecken: dc.w	$140,$00e0	; SPR0POS - Horizontale Position


Erklrt wird die Farbabstufung so:

Ich warte auf das Zeilenende und der Copper Move fr den Farbwechsel erfolgt in 
der nchsten Zeile. Warum erfolgt der Farbwechsel nicht wie erwartet in der
neuen Zeile, sondern noch auf der alten Zeile am rechten Rand? 

ross Antwort:
Was Sie als "Ende der Zeile" bezeichnen, ist eigentlich nur der horizontale
Agnus-Zhler, der seinen fest verdrahteten Hchstwert erreicht, bevor der
vertikale Zhler hochgezhlt wird (tatschlich ist es nicht genau der Zyklus, 
in dem die Erhhung erfolgt, aber das ist eine andere Frage ...).

Das Anzeigegert wei absolut nichts darber, was im Chipsatz passiert, und 
kann daher nur auf die horizontale Leerzeile warten (die die Abdeckung der
Synchronsignale vorbereitet, wenn das Composite-Video im Ausgang verwendet 
wird, darum kmmert sich Denise) und den Hsync-Impuls fr "die Zeile ist
physisch beendet, gehe zurck nach links und zeichne eine neue" (und darum 
kmmert sich Agnus).

Diese Signale liegen recht nahe am Start der Zhler von Agnus/Denise, aber 
sicher nicht im Zyklus 0 :)
[Ich werde nicht beschreiben, wo sie sich tatschlich befinden und wie sie
verwaltet werden, die Diskussion wrde sehr themenfremd und kontextlos sein,
auf jeden Fall gibt es andere Threads, in denen es beschrieben wird, zum 
Beispiel den ber undokumentiertes Zeug] 

Es ist jedoch klar, warum die Zhler und das Zeilenende auf diese Weise
verwaltet werden: Es gibt viele DMA-Zyklen, die sich nicht ausschlielich auf
die Anzeige auswirken, und es ist logisch, dies whrend des horizontalen
Blanks oder besser unmittelbar nach dem letzten mglichen Bitplane-DMA-Zyklus
(Aktualisieren, Disk, Audio usw.) durchzufhren.
Und da die eigentliche Anzeige der abgerufenen Daten auch verzgert werden 
kann (siehe BPLCON1) und daher im uersten rechten Teil der Zeile angezeigt
werden kann, mssen sowohl das Blank als auch die Synchronisierung "spter"
im letzten Zyklus der Zeile durchgefhrt werden.

Ich hoffe, die Grnde fr die Entscheidungen der Designer sind nun etwas
klarer ;)