
; Listing25c4.s		horizontales Spritemultiplexing mit wait und SPRxPOS
;					mit Copper-Move	Folge oder Copper-Wait ("halbautomatischer Modus")

	SECTION R'nR,CODE

Anfang:
	move.l	4.w,a6			; Execbase
	jsr	-$78(a6)			; Disable
	lea	GfxName(PC),a1		; Libname
	jsr	-$198(a6)			; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop	; wir speichern die alte COP

	; Pointen auf das "leere" Bild

	MOVE.L	#BITPLANE,d0	; Adresse der Bitplane
	LEA	BPLPOINTERS,A1		; Bitplanepointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	; Pointen auf den Sprite wird hier nicht bentigt

	move.l	#MEINSPRITE,d0	; Adresse des Sprite in d0
	lea	SpritePointers,a1	; Pointer in der Copperlist
	move.w	d0,6(a1)
	move.w	d0,d7			; fr initcopper 2 zurcksetzen
	;add.b	#4,d7			; normalerweise, aber wir nutzen einen kleinen Trick aus	
	swap	d0
	move.w	d0,2(a1)
	
;-------------------------------	
initcopper:							; alle 32 Pixel
	lea coppersprite,a0
	move.l	#$2c39fffe,d0			; wait
	move.l	#$01402c40,d1			; SPR0POS V=$2c, H=$40
	moveq #0,d2						; Zeile des Sprites

	moveq #13-1,d4					; 13 Zeilen	
zeile:
	moveq #10,d3					; 10 Anzahl Sprites horizontal nebeneinander
hor:
	move.l	d0,(a0)+				; wait
	move.l	d1,(a0)+				; SPR0POS V=$2c, H=$40+16
	add.b	#16,d1					; nchste horizontale Position
	add.l	#$00100000,d0			; nchste horizontale Waitposition +16
	dbf d3,hor
	move.l	#$2c39fffe,d0			; wait zurcksetzen
	add.l #$01000000,d2				; nchste Zeile
	add.l d2,d0						; zur Startzeile addieren

	move.b  #$40,d1					; SPR0POS zurcksetzen
	dbf d4,zeile
	
;-------------------------------
initcopper2:						; alle 24 Pixel
	
	move.w  #$0122,(a0)+			; SPR0PTL		
	move.w	d7,(a0)+				; low-Anteil Adresse eintragen
									; unten erklrt
	move.l	#$4c01fffe,(a0)+		; am Anfang der Zeile
	move.l	#$01404c40,(a0)+		; um den ersten DMA-Abruf zu erhalten
	move.l	#$01425900,(a0)+

	move.l	#$4c39fffe,d0			; wait vorbereiten um anschlieend im Raster zu bleiben
	move.l	#$01404c40,d1			; SPR0POS V=$4c, H=$40
	moveq #0,d2						; Zeile des Sprites

	moveq #13-1,d4					; 13 Zeilen	
zeile2:
	moveq #14-1,d3					; 14 Anzahl Sprites horizontal nebeneinander
hor2:
	move.l	d0,(a0)+				; wait setzen
	move.l	d1,(a0)+				; SPR0POS V=$1a, H=$40+16 bzw. H=$40+8
	tst.b	a8_16					; Flag abfragen
	bne a16
a8:
	add.b	#8,d1					; nchste horizontale Position +8 
	add.l	#$00080000,d0			; nchste horizontale Waitposition +16
	sne	a8_16						; Flag nicht setzen
	bra hor2b
a16:
	add.b	#16,d1					; nchste horizontale Position + 16
	add.l	#$00100000,d0			; nchste horizontale Waitposition +16
	seq	a8_16						; Flag setzen
hor2b:	
	dbf d3,hor2
	move.l	#$4c39fffe,d0			; wait zurcksetzen
	add.l #$01000000,d2				; nchste Zeile
	add.l d2,d0						; zur Startzeile addieren

	move.b  #$40,d1					; SPR0POS zurcksetzen
	dbf d4,zeile2

;-------------------------------
initcopper3:
; einzelnes Sprite mit wait positionieren
	move.w  #$0122,(a0)+			; SPR0PTL		
	move.w	d7,(a0)+				; low-Anteil Adresse eintragen
									; unten erklrt
	move.l	#$6c01fffe,(a0)+		; am Anfang der Zeile
	move.l	#$01406c90,(a0)+		; um den ersten DMA-Abruf zu erhalten
	move.l	#$01427900,(a0)+
	
	; wait fr den Farbwechsel um genau an der horizontalen Position $90 
	; (horizontale Spriteposition einen Farbwechsel zu erhalten)
	move.l	#$7a8ffffe,(a0)+		; $hpos-1 $90-1=$8f
	move.l	#$01800f00,(a0)+		; Farbe rot setzen
	move.l	#$7b01fffe,(a0)+		; Beginn nchste Zeile
	move.l	#$01800000,(a0)+		; Farbe schwarz zurcksetzen

	move.l	#$7b91fffe,(a0)+		; $hpos-1 $90+1=$91
	move.l	#$01800f00,(a0)+		; Farbe rot setzen
	move.l	#$7c01fffe,(a0)+		; Beginn nchste Zeile
	move.l	#$01800000,(a0)+		; Farbe schwarz zurcksetzen
	
	;-------------------------------
	move.l	#$fffffffe,a0			; Ende der Copperlist
;-------------------------------

	move.l	#COPPERLIST,$dff080	; unsere COP
	move.w	d0,$dff088		; START COP
	move.w	#0,$dff1fc		; NO AGA!
	move.w	#$c00,$dff106	; NO AGA!

mouse:
	btst	#6,$bfe001		; Maustaste gedrckt?
	bne.s	mouse

	move.l	OldCop(PC),$dff080	; Pointen auf die alte SystemCopperlist
	move.w	d0,$dff088		; Starten die alte SystemCopperlist

	move.l	4.w,a6
	jsr	-$7e(a6)			; Enable
	move.l	gfxbase(PC),a1
	jsr	-$19e(a6)			; Closelibrary
	rts

;	Daten

GfxName:
	dc.b	"graphics.library",0,0


GfxBase:
	dc.l	0

OldCop:
	dc.l	0

	; Variablen

a8_16:		dc.b	0			; addiere 8 oder 16

	SECTION GRAPHIC,DATA_C

COPPERLIST:
SpritePointers:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

	dc.w	$8e,$1a5c		; DiwStrt
	dc.w	$90,$80d4		; DiwStop
	dc.w	$92,$20			; DdfStart
	dc.w	$94,$d8			; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod

				; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres

BPLPOINTERS:
	dc.w	$e0,0,$e2,0		; erste Bitplane

	dc.w	$180,$000		; color0	; Hintergrund Schwarz
	dc.w	$182,$123		; color1	; Farbe 1 der Bitplane, die
							; in diesem Fall leer ist,
							; und deswegen nicht erscheint

	dc.w	$1A2,$F00		; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0		; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0		; Color19, oder COLOR3 des Sprite0 - GELB

coppersprite:
	blk.l	2000,$fffffffe 

	dc.w	$FFFF,$FFFE		; Ende der Copperlist


; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:		; Lnge 13 Zeilen
VSTART:
	dc.b $2c	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $3f	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $39	; $2c+13=$39 - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.


	SECTION LEERESPLANE,BSS_C	; Eine auf 0 gesetzte Bitplane, wir
							; mssen es verwenden, denn ohne Bitplane
							; ist es nicht mglich, die Sprites
							; zu aktivieren
BITPLANE:
	ds.b	40*256			; Bitplane auf 0 Lowres

	end
	

Erklrung:

Bedingt durch die Dauer von 16 Pixeln fr einen Copper Wait sind horizontale
Wiederholungen nur alle 24 bzw. 32 Pixel mglich. 
(Copper Wait+Copper Move = 16 Pixel + 8 Pixel=24 Pixel)

Hinweis: bis 4 Bitebenen:
Copper-Move bentigt	8 Pixel lores
Copper-wait bentigt	16 Pixel lowres
Bei Verwenung von mehr als 4 Bitebenen wrde es die Mglichkeiten weiter 
einschrnken.

Variante 1: Abstand 32pixel
Wenn wir die horizontales Spritemultiplexing mit vorangestellten Copper-Waits
erzielen wollen knnen wir dies nur mit einer Lcke von 16Pixeln zueinander
unabhngig voneinader erreichen.

Variante 2: Abstand 24Pixel
Es gibt eine Ausnahme, bei der wir bis zu zwei Sprites ohne Lcke zueinander
direkt nebeneinader platzieren knnen. Dies knnten wir dann aber ebenso gut
durch folgende Copper-NOP erzielen.

Um eine Positionierung eines Sprites ber ein Copper-Wait zu erreichen wren
folgende Schritte zu ttigen:

1. vertikale und horizontale Startposition des Sprites festlegen 
   SPRxPOS vvhh ; hh auf volle 16Bit abrunden

Mgliche Werte fr hh sind: 
	$30	- 6
	$38
	$40	- 8
	$48
	$50	- 10
	$58
	$60	- 12
	$68
	$70	- 14
	$78
	$80	- 16
	$88
	$90	- 18	- Mitte
	$98
	$A0	- 20
	$A8
	$B0	- 22
	$B8
	$C0	- 24
	$C8
	$D0	- 26
	$D8
	$E0	- 28	- Ende (letzte)
	
Formel: x=(n*8) ; mit n= 6 bis 28

fr DDFSTRT = $61 = ($60/2)=$30		$60=96	--> 96/16  ; d.h. n=6
fr DDFSTRT = $81 = ($80/2)=$40		$80=128	--> 128/16 ; d.h. n=8
	Theoretisch ($1c0/2)=$e0		$1C0=448	--> 448/16 ; d.h. n=28

2. vs - vertikale Startposition ist vertikale Waitposition vv
3. das passende Wait ist folgendermassen zu whlen:

	dc.w $vvhh,$fffe	; allg. Anweisung
	dc.w $0140,$vshs	; SPR0POS

->  dc.w $2c39,$fffe	; hh 39 bis 3d (z.B. hs-1)
	dc.w $0140,$2c40	; SPR0POS

Das Wait muss in der Zeile direkt (bzw. sptestens) vor dem letzten BPL1-Abruf 
erfolgen. Dies setzt nur die Position.

Ggf. muss das Sprite-DMA in der ersten Zeile gestartet werden.

- Spritepointer zurcksetzen auf Anfang Bilddaten des Sprites
- dc.w $4c01,$fffe	; wait an Anfang der Zeile
- dc.w $0140,$2c40	; SPR0POS
 
Dabei sind maximal 10 Sprites parallel darstellbar.

zum "Trick":
in dem wir den Spritepointer ohne wait und damit noch auf der letzen Zeile des
Sprites ndern wird der Spritepointer mit der nchsten Zeile automatisch nach
dem Abrufen der Spritedaten erhht und steht nun auf dem ersten Bilddatenpaar.
Durch:
	 move.l	#$4c01fffe,(a0)+		; am Anfang der Zeile
	 move.l	#$01404c40,(a0)+		; um den ersten DMA-Abruf zu erhalten

erfolgt dann der Datenabruf in dieser Zeile.

Bei Initcopper 3 wurde durch den Copper ein Farbwechsel auf der Zeile 
durchgefhrt. Es beantwortet wie das wait eingestellt werden muss um genau
an einer gewnschten Position einen Farbwechsel zu erhalten.