
; Listing25g.s		Sprite in interlace 
;			

	SECTION	Interlace,CODE

;	Include	"DaWorkBench.s"		; entferne das; vor dem Speichern mit "WO"

*****************************************************************************
	include "/Sources/startup2.s"	; speichern copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	EQU	%1000001110100000	; nur copper und bitplane DMA


WaitDisk	EQU	30

scr_bytes	= 80				; Anzahl der Bytes fr jede horizontale Zeile.
								; Daraus berechnen wir die Bildschirmbreite,
								; Multiplizieren von Bytes mit 8: normaler Bildschirm 320/8 = 40
								; z.B. fr einen 336 Pixel breiten Bildschirm 336/8 = 42
								; Beispielbreiten:
								; 264 pixel = 33 / 272 pixel = 34 / 280 pixel = 35
								; 360 pixel = 45 / 368 pixel = 46 / 376 pixel = 47
								; ... 640 pixel = 80 / 648 pixel = 81 ...

scr_h		= 256				; Bildschirmhhe in Zeilen
scr_x		= $81				; Startbildschirm, XX-Position (normal $xx81) (129)
scr_y		= $2c				; Startbildschirm, YY-Position (normal $2cxx) (44)
scr_res		= 2					; 2 = HighRes (640*xxx) / 1 = LowRes (320*xxx)
scr_lace	= 1					; 0 = non interlace (xxx*256) / 1 = interlace (xxx*512)
ham			= 0					; 0 = non ham / 1 = ham
scr_bpl		= 1					; Anzahl Bitplanes

; Parameter automatisch berechnet

scr_w		= scr_bytes*8		; Bildschirmbreite
scr_size	= scr_bytes*scr_h	; Gre in Bytes des Bildschirms
BPLC0	= ((scr_res&2)<<14)+(scr_bpl<<12)+$200+(scr_lace<<2)+(ham<<11)
DIWS	= (scr_y<<8)+scr_x
DIWSt	= ((scr_y+scr_h/(scr_lace+1))&255)<<8+(scr_x+scr_w/scr_res)&255
DDFS	= (scr_x-(16/scr_res+1))/2
DDFSt	= DDFS+(8/scr_res)*(scr_bytes/2-scr_res)


START:
	MOVE.L	#BITPLANE,d0		; wohin pointen
	LEA	BPLPOINTERS1,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	

	MOVE.L	#BITPLANE+80,d0		; wohin pointen
	LEA	BPLPOINTERS2,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	
	MOVE.L	#Cop_lace2,d0		; wohin pointen
	LEA	COP_Pointer1,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.L	#Cop_lace1,d0		; wohin pointen
	LEA	COP_Pointer2,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.L	#MEINSPRITE1,d0		; Adresse des Sprite in d0
	LEA	SpritePointers1,a1		; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.L	#MEINSPRITE2,d0		; Adresse des Sprite in d0
	LEA	SpritePointers2,a1		; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	
	MOVE.L	#MEINSPRITE,d0		; Adresse des Sprite in d0
	LEA	SpritePointers1+8,a1	; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.L	#MEINSPRITE,d0		; Adresse des Sprite in d0
	LEA	SpritePointers2+8,a1	; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.W	#DMASET,$96(a5)		; DMACON - aktivieren bitplane, copper
	;move.l	#Copperlist,$dff084 ; COPL2
	move.w	#0,$1fc(a5)			; AGA deaktivieren
	move.w	#$c00,$106(a5)		; AGA deaktivieren
	move.w	#$11,$10c(a5)		; AGA deaktivieren

;-------------------------------
initcopper1:
	move.l	#$2c01fffe,d0		; 1. wait			
	move.l	#$01402c40,d1		; SPR0POS V=$2c, H=$40 
	move.l	#$01423300,d2		; SPR0CTL V=$39, H=0	$2c+13=$39

	MOVE.L	#MEINSPRITE1+4,d4	; Adresse des Sprite in d0 auf Spritedaten!
								; nicht auf die Steuerwrter!		
	lea	coppersprite1,a0		; Adresse copperlist 
	move.l	d0,(a0)+			; setzt das erste wait	
;---------------
; Spritepointer setzen in Copperlist
	move.w	#$0120,(a0)+		; SPR0PTH
	swap d4	
	move.w	d4,(a0)+			; hi-Anteil Adresse eintragen
	move.w  #$0122,(a0)+		; SPR0PTL
	swap d4			
	move.w	d4,(a0)+			; low-Anteil Adresse eintragen
;----------------
    move.l	d1,(a0)+			; SPR0POS
	move.l	d2,(a0)+			; SPR0CTL

	move.l	#$fffffffe,a0		; Ende der Copperlist
;-------------------------------

;-------------------------------
initcopper2:
	move.l	#$2c01fffe,d0		; 1. wait			
	move.l	#$01402c40,d1		; SPR0POS V=$2c, H=$40 
	move.l	#$01423300,d2		; SPR0CTL V=$39, H=0	$2c+13=$39

	MOVE.L	#MEINSPRITE2+4,d4	; Adresse des Sprite in d0 auf Spritedaten!
								; nicht auf die Steuerwrter!		
	lea	coppersprite2,a0		; Adresse copperlist 
	move.l	d0,(a0)+			; setzt das erste wait	
;---------------
; Spritepointer setzen in Copperlist
	move.w	#$0120,(a0)+		; SPR0PTH
	swap d4	
	move.w	d4,(a0)+			; hi-Anteil Adresse eintragen
	move.w  #$0122,(a0)+		; SPR0PTL
	swap d4			
	move.w	d4,(a0)+			; low-Anteil Adresse eintragen
;----------------
    move.l	d1,(a0)+			; SPR0POS
	move.l	d2,(a0)+			; SPR0CTL

	move.l	#$fffffffe,a0		; Ende der Copperlist
;-------------------------------

	bsr LACEINT					; LOF-Bit testen und Copperpointer eintragen

mouse:
	MOVE.L	#$1ff00,d1			; Bit zur Auswahl durch UND
	MOVE.L	#$01000,d2			; warte auf Zeile $010
Waity1:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; warte auf Zeile $010
	BNE.S	Waity1
Waity2:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; warte auf Zeile $010
	Beq.S	Waity2
	
	; bsr here					; weitere Effekte einfgen						

	btst	#6,$bfe001			; Maus gedrckt?
	bne.s	mouse

	rts

******************************************************************************
; INTERLACE ROUTINE - Test Bit LOF (Long Frame) um zu wissen, ob Sie
; gerade oder ungerade Zeilen anzeigen und entsprechend wechseln mssen.
******************************************************************************
LACEINT:
	btst.b	#15-8,4(A5)			; VPOSR LOF bit?
	Beq.s	Faidispari			; wenn ja, zeigen Sie auf ungerade Zeilen
	
								; Starten der Ansicht von den geraden Zeilen!
								; zweitens: gerade Zeilen werden angezeigt!
	move.l	#Cop_lace1,$dff080	; unsere COP
	move.w	d0,$dff088			; START COP
	rts

FaiDispari:
	move.l	#Cop_lace2,$dff080	; unsere COP
	move.w	d0,$dff088			; START COP
	rts
	

******************************************************************************

	SECTION	GRAPHIC,DATA_C
	
Cop_lace1:
BPLPOINTERS1:
	dc.w	$e0,0,$e2,0		; erste Bitplane

SpritePointers1:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

COP_Pointer1:
	dc.w 	$80,$0,$82,$0	; COP1LC auf Cop_lace2 setzen 

	dc.w	$8e,DIWS	; DiwStrt
	dc.w	$90,DIWSt	; DiwStop
	dc.w	$92,DDFS	; DdfStart
	dc.w	$94,DDFSt	; DdfStop

	dc.w	$102,0		; BplCon1
	dc.w	$104,$24	; BplCon2
	dc.w	$108,80		; Bpl1Mod \ INTERLACE: modulo = Lnge Zeile!
	dc.w	$10a,80		; Bpl2Mod / um sie zu berspringen (die geraden)

				; 5432109876543210
;	dc.w	$100,%1001001000000100	; 1 bitplane, HIRES LACE 640x512
;								; Beachten Sie das Bit 2 Set fr LACE!!

	dc.w	$100,BPLC0			; BplCon0 -> lassen Sie es uns automatisch berechnen!
	
	dc.w	$180,$226			; color0 - Hintergrund
	dc.w	$182,$0b0			; color1 - plane 1 Position normal, und
								; der "klebende" Teil an der Spitze.

    dc.w	$1A2,$F00			; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0			; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0			; Color19, oder COLOR3 des Sprite0 - GELB

coppersprite1:
	blk.l	10,$fffffffe
	 
	dc.w 	$ffff,$fffe			; Ende copperlist
	
;------------------------------------------------------------

Cop_lace2:
BPLPOINTERS2:
	dc.w	$e0,0,$e2,0		; erste Bitplane+80
SpritePointers2:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

COP_Pointer2:
	dc.w 	$80,$0,$82,$0	; COP1LC auf Cop_lace1 setzen 

	dc.w	$8e,DIWS	; DiwStrt
	dc.w	$90,DIWSt	; DiwStop
	dc.w	$92,DDFS	; DdfStart
	dc.w	$94,DDFSt	; DdfStop

	dc.w	$102,0		; BplCon1
	dc.w	$104,$24	; BplCon2
	dc.w	$108,80		; Bpl1Mod \ INTERLACE: modulo = Lnge Zeile!
	dc.w	$10a,80		; Bpl2Mod / um sie zu berspringen (die geraden)

				; 5432109876543210
;	dc.w	$100,%1001001000000100	; 1 bitplane, HIRES LACE 640x512
;								; Beachten Sie das Bit 2 Set fr LACE!!

	dc.w	$100,BPLC0			; BplCon0 -> lassen Sie es uns automatisch berechnen!
	
	dc.w	$180,$226			; color0 - Hintergrund
	dc.w	$182,$0b0			; color1 - plane 1 Position normal, und
								; der "klebende" Teil an der Spitze.

    dc.w	$1A2,$F00			; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0			; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0			; Color19, oder COLOR3 des Sprite0 - GELB

coppersprite2:
	blk.l	10,$fffffffe 

	dc.w	$ffff,$fffe			; Ende copperlist



; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:		; Lnge 13 Zeilen
VSTART:
	dc.b $60	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $A0	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $6d	; $60+13=$6d - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.


; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE1:		; Lnge 13 Zeilen
VSTART1:
	dc.b $60	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART1:
	dc.b $D0	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP1:
	dc.b $67	; $60+13=$6d - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 ;dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 ;dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 ;dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 ;dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 ;dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 ;dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.


MEINSPRITE2:		; Lnge 13 Zeilen
VSTART2:
	dc.b $60	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART2:
	dc.b $D0	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP2:
	dc.b $66	; $60+13=$6d - Vertikale Endposition des Sprite
	dc.b $00
 ;dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 ;dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 ;dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 ;dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 ;dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 ;dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 ;dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.



******************************************************************************

	SECTION	MIOPLANE,BSS_C

BITPLANE:
	ds.b	scr_bytes*scr_h		; 80*512 eine bitplane Hires int. 640x512

	end

Erklrung:

Normalerweise werden Sprites immer in lowres angezeigt auch wenn der Bildschirm
in interlace eingestellt ist.
Es ist allerdings mglich auch Sprites in interlace anzuzeigen. Dazu ist es
notwendig die Spritebilddaten in zwei Sprites zu trennen, wobei jede zweite
Zeile bersprungen wird. Die Spritehhe muss auch auf die Anzahl der Zeilen
eingestellt werden. Sie reduziert sich in jedem Fall um die Hlfte.
Und die Anzeige des Sprites erfolgt durch Wechsel der Copperlisten wobei in
den Copperlisten die entsprechenden Spritepointer zuvor eingestellt werden
mssen.
