
; Listing10f2.s		Viele BOBs mit "Fake" und "Double Buffering" Hintergrund
				; Linke Taste zum Beenden.

	SECTION	bau,code

;	Include	"DaWorkBench.s"	entferne das ; vor dem Speichern mit "WO"

*****************************************************************************
	include	"/Sources/startup1.s"	; speichern Copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	EQU	%1000001111000000	; bitplane, copper, blitter DMA


; konstante Kanten.

Lowest_Floor	equ	200			; Unterkante
Right_Side	equ	287				; Rand rechts


START:
; Die ersten drei bitplanes sind auf die ScambiaBuffer-Routine ausgerichtet
; Lass uns die vierte Bitebene fr (den Hintergrund) setzen

	LEA	BPLPOINTERS,A0			; Bitplanepointer
	move.l	#SfondoFinto,d0		; Adresse Hintergrund
	move.w	d0,30(a0)			; der Hintergrund ist bitplane 4
	swap	d0	
	move.w	d0,26(a0)			; schreibe hohes Wort

	lea	$dff000,a5				; CUSTOM REGISTER in a5
	MOVE.W	#DMASET,$96(a5)		; DMACON - einschalten bitplane, copper, blitter
	move.l	#COPPERLIST,$80(a5)	; Zeiger COP
	move.w	d0,$88(a5)			; Start COP
	move.w	#0,$1fc(a5)			; AGA deaktivieren
	move.w	#$c00,$106(a5)		; AGA deaktivieren
	move.w	#$11,$10c(a5)		; AGA deaktivieren

mouse:
	MOVE.L	#$1ff00,d1			; Bit zur Auswahl durch UND
	MOVE.L	#$13000,d2			; Warte auf Zeile $130 (304)
Waity1:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; Whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; Warte auf Zeile $130 (304)
	BNE.S	Waity1

	bsr.w	ScambiaBuffer		; Diese Routine tauscht die 2 Puffer aus

	bsr.w	CancellaSchermo		; Bildschirm lschen

	lea	Oggetto_1,a4			; Adresse erstes Objekt
	moveq	#6-1,d6				; 6 Objekte

Ogg_loop:
	bsr.s	MuoviOggetto		; bewege Bob
	bsr.w	DisegnaOggetto		; zeichne Bob

	addq.l	#8,a4				; Zeige auf das nchste Objekt

	dbra	d6,Ogg_loop

;	btst	#6,2(a5)
;WBlit_coppermonitor:
;	btst	#6,2(a5)
;	bne.s	WBlit_coppermonitor

	move.w	#$aaa,$180(a5)		; copper monitor: Farbe grau

	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	mouse				; wenn nicht, gehe zurck zur mouse:

	rts

;****************************************************************************
; Diese Routine tauscht die 2 Puffer durch den Austausch der Adressen der
; VIEW_BUFFER und DRAW_BUFFER Variablen aus.
; Es aktualisiert auch die Anweisungen welche die BPLxPT-Register in die 
; copperlist laden, so dass sie auf den neuen Puffer zeigen, der angezeigt 
; werden soll.
;****************************************************************************

;	        |\__/,|   (`\
;	      _.|o o  |_   ) )
;	  ---(((---(((---------

ScambiaBuffer:
	move.l	draw_buffer(pc),d0	; Tausche den Inhalt 
	move.l	view_buffer(pc),draw_buffer	; der Variablen aus
	move.l	d0,view_buffer		; in d0 steht die Adresse
								; des neuen View-Puffers
									
; Aktualisieren der copperliste, indem sie auf die Bitebenen 
; des neuen Puffers zeigen, der angezeigt werden soll

	LEA	BPLPOINTERS,A1			; Zeiger COP
	MOVEQ	#3-1,D1				; Anzahl der bitplanes
POINTBP:
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	swap	d0
	ADD.L	#40*256,d0			; + Bitplane Lnge (hier 256 Zeilen)
	addq.w	#8,a1
	dbra	d1,POINTBP

	rts

;****************************************************************************
; Diese Routine bewegt einen Bob, indem berprft wird, dass die Kanten nicht 
; berschritten werden
; A4 - zeigt auf die Datenstruktur, die die Position und die Geschwindigkeit 
; vom Bob enthlt
;****************************************************************************

MuoviOggetto:
	move.w	(a4),d0				; Position X
	move.w	2(a4),d1			; Position Y
	move.w	4(a4),d2			; dx (Geschwindigkeit X)
	move.w	6(a4),d3			; dy (Geschwindigkeit Y)
	add.w	d2,d0				; x = x + dx
	add.w	d3,d1				; y = y + dy

	btst	#15,d1				; Kontrolle hohe Kante (Y=0)
	beq.s	UO_NoBounce4		; wenn das Y negativ ist...
	neg.w	d1					; .. springt er zurck
	neg.w	d3					; umgekehrte Bewegungsrichtung
UO_NoBounce4:

	cmp.w	#Lowest_Floor,d1	; Kontrolle Unterkante
	blt.s	UO_NoBounce1

	neg.w	d3					; ndere das Geschwindigkeitszeichen dy
								; Umkehr der Bewegungsrichtung
	move.w	#Lowest_Floor,d1	; Beginne von der Kante
UO_NoBounce1:

	cmp.w	#Right_Side,d0		; berprfe die rechte Kante
	blt.s	UO_NoBounce2		; wenn es die rechte Kante berschreitet..
	sub.w	#Right_Side,d0		; Abstand vom Rand
	neg.w	d0					; Die Entfernung umkehren
	add.w	#Right_Side,d0		; Board-Koordinate hinzufgen
	neg.w	d2					; umgekehrte Bewegungsrichtung
UO_NoBounce2:
	btst	#15,d0				; berprfe den linken Rand (X = 0)
	beq.s	UO_NoBounce3		; wenn das X negativ ist...
	neg.w	d0					; ..  springt er zurck
	neg.w	d2					; umgekehrte Bewegungsrichtung
UO_NoBounce3:
	move.w	d0,(a4)				; aktualisiere Position und Geschwindigkeit
	move.w	d1,2(a4)
	move.w	d2,4(a4)
	move.w	d3,6(a4)

	rts
	
;****************************************************************************
; Diese Routine zeichnet ein BOB.
; A4 - zeigt auf die Datenstruktur, die die Position und die Geschwindigkeit 
; vom Bob enthlt
;****************************************************************************

DisegnaOggetto:
	move.l	draw_buffer(pc),a0	; Adresse Puffer Zeichnung
	move.w	2(a4),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile belegt 40 Bytes
	add.l	d0,a0				; offset hinzufgen Y
	move.w	(a4),d0				; Koordinate X
	move.w	d0,d1				; Kopie
	and.w	#$000f,d0			; wir whlen die ersten 4 Bits, weil sie 
								; in den Shifter von Kanal A eingefgt werden
	lsl.w	#8,d0				; Die 4 Bits werden zum High-Nibble 
	lsl.w	#4,d0				; des Wortes bewegt...
	or.w	#$0FCA,d0			; ..rechts, um in das BLTCON0-Register zu kommen
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.l	#$0000fffe,d1		; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Ball_Bob,a1				; Zeiger auf die Figur
	lea	Ball_Mask,a2			; Zeiger auf die Maske
	moveq	#3-1,d7				; bitplane Zhler

DrawLoop:
	btst	#6,2(a5)
WBlit2:
	btst	#6,2(a5)
	bne.s	WBlit2

	move.w	d0,$40(a5)			; BLTCON0 - schreibe Verschiebungswert
	move.w	d0,d1				; Kopie von BLTCON0,
	and.w	#$f000,d1			; Verschiebungswert auswhlen..
	move.w	d1,$42(a5)			; und schreibe es in BLTCON1 (fr Kanal B)

	move.l	#$ffff0000,$44(a5)	; BLTAFWM und BLTLWM

	move.w	#$FFFE,$64(a5)		; BLTAMOD
	move.w	#$FFFE,$62(a5)		; BLTBMOD

	move.w	#40-6,$66(a5)		; BLTDMOD
	move.w	#40-6,$60(a5)		; BLTCMOD

	move.l	a2,$50(a5)			; BLTAPT - Zeiger Maske
	move.l	a1,$4c(a5)			; BLTBPT - Zeiger Figur
	move.l	a0,$48(a5)			; BLTCPT - Zeiger Hintergrund
	move.l	a0,$54(a5)			; BLTDPT - Zeiger bitplanes

	move.w	#(31*64)+3,$58(a5)	; BLTSIZE - Hhe 31 Zeilen
				 				; Breite 3 word (48 pixel).

	add.l	#4*31,a1			; Adresse nchste Bitebene Bild
	add.l	#40*256,a0			; Adresse nchste Bitebene Ziel
	dbra	d7,DrawLoop
	
	rts

;****************************************************************************
; Diese Routine lscht den Bildschirm mit dem Blitter.
;****************************************************************************

CancellaSchermo:
	moveq	#3-1,d7				; 3 bitplanes
	lea	BITPLANE1,a0			; Adresse pitplane

canc_loop:
	btst	#6,2(a5)
WBlit3:
	btst	#6,2(a5)			 ; warte auf das Ende des Blitters
	bne.s	wblit3

	move.l	#$01000000,$40(a5)	; BLTCON0 und BLTCON1: Lschung
	move	#$0000,$66(a5)		; BLTDMOD=0
	move.l	a0,$54(a5)			; BLTDPT
	move.w	#(64*256)+20,$58(a5)	; BLTSIZE (Blitter starten !)
								; lsche den gesamten Bildschirm

	add.l	#40*256,a0			; Adresse nchstes plane Ziel
	dbra	d7,canc_loop
	rts

; Zeiger auf die 2 Puffer
view_buffer	dc.l	BITPLANE1	; Puffer Anzeige
draw_buffer	dc.l	BITPLANE1b	; Puffer Design

; Datenobjekte
; Das ist die Datenstruktur, die die Geschwindigkeit und Position der 
; Bobs enthalten.
; Jede Datenstruktur besteht aus 4 Wrtern, die der Reihe nach enthalten:
; X-POSITION, Y-POSITION, X-GESCHWINDIGKEIT, Y-GESCHWINDIGKEIT

Oggetto_1:
	dc.w	32,53				;  x / y   - Position
	dc.w	-3,1				; dx / dy  - Geschwindigkeit

Oggetto_2:
	dc.w	132,62				;  x / y   - Position
	dc.w	2,-1				; dx / dy  - Geschwindigkeit

Oggetto_3:
	dc.w	232,42				;  x / y   - Position  
	dc.w	3,1					; dx / dy  - Geschwindigkeit

Oggetto_4:
	dc.w	2,20				;  x / y   - Position
	dc.w	-5,1				; dx / dy  - Geschwindigkeit

Oggetto_5:
	dc.w	60,80				;  x / y   - Position 
	dc.w	6,1					; dx / dy  - Geschwindigkeit

Oggetto_6:
	dc.w	50,75				;  x / y   - Position
	dc.w	-5,1				; dx / dy  - Geschwindigkeit

;****************************************************************************

	SECTION	MY_COPPER,CODE_C

COPPERLIST:
	dc.w	$8E,$2c81			; DiwStrt
	dc.w	$90,$2cc1			; DiwStop
	dc.w	$92,$38				; DdfStart
	dc.w	$94,$d0				; DdfStop
	dc.w	$102,0				; BplCon1
	dc.w	$104,0				; BplCon2

	dc.w	$108,0				; MODULO
	dc.w	$10a,0

BPLPOINTERS:
	dc.w	$e0,$0000,$e2,$0000	; erste bitplane
	dc.w	$e4,$0000,$e6,$0000
	dc.w	$e8,$0000,$ea,$0000
	dc.w	$ec,$0000,$ee,$0000

	dc.w	$180,$000			; color0 - Hintergrund
	dc.w	$190,$000

 	dc.w	$182,$0A0			; Farbe von 1 bis 7
 	dc.w	$184,$040
 	dc.w	$186,$050
 	dc.w	$188,$061
 	dc.w	$18A,$081
 	dc.w	$18C,$020
 	dc.w	$18E,$6F8

	dc.w	$192,$0A0			; Farbe von 9 bis 15
	dc.w	$194,$040			; sie sind die gleichen Werte
	dc.w	$196,$050			; geladen in den Registern 1 bis 7
	dc.w	$198,$061
	dc.w	$19a,$081
	dc.w	$19c,$020
	dc.w	$19e,$6F8

	dc.w	$190,$345			; Farbe 8 - pixel zu 1 des Hintergrunds

	dc.w	$100,$3200			; bplcon0 - 3 bitplanes lowres

	dc.w	$8007,$fffe			; warte Linie $80
	dc.w	$100,$4200			; bplcon0 - 4 bitplanes lowres
								; Bitebene 4 aktivieren (Hintergrund)

; In diesem Feld wird der Teil des Hintergrunds angezeigt

	dc.w	$e007,$fffe			; warte Linie $e0
	dc.w	$100,$3200			; bplcon0 - 3 bitplanes lowres

	dc.w	$FFFF,$FFFE			; Ende copperlist

;****************************************************************************

; Figur Bob
Ball_Bob:
 DC.W $0000,$0000,$0000,$0000,$0000,$0000,$003F,$8000	; plane 1
 DC.W $00C1,$E000,$017C,$E000,$02FE,$3000,$05FF,$5400
 DC.W $07FF,$1800,$0BFE,$AC00,$03FF,$1A00,$0BFE,$AC00
 DC.W $11FF,$1A00,$197D,$2C00,$0EAA,$1A00,$1454,$DC00
 DC.W $0E81,$3800,$0154,$F400,$02EB,$F000,$015F,$D000
 DC.W $00B5,$A000,$002A,$8000,$0000,$0000,$0000,$0000
 DC.W $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
 DC.W $0000,$0000,$0000,$0000,$0000,$0000

 DC.W $000F,$E000,$007F,$FC00,$01FF,$FF00,$03FF,$FF80	; plane 2
 DC.W $07C1,$FFC0,$0F00,$FFE0,$1E00,$3FF0,$3C40,$5FF8
 DC.W $3CE0,$1FF8,$7840,$2FFC,$7800,$1FFC,$7800,$2FFC
 DC.W $F800,$1FFE,$F800,$2FFE,$FE00,$1FFE,$FC00,$DFFE
 DC.W $FE81,$3FFE,$FF54,$FFFE,$FFEB,$FFFE,$7FFF,$FFFC
 DC.W $7FFF,$FFFC,$7FFF,$FFFC,$3FFF,$FFF8,$3FFF,$FFF8
 DC.W $1FFF,$FFF0,$0FFF,$FFE0,$07FF,$FFC0,$03FF,$FF80
 DC.W $01FF,$FF00,$007F,$FC00,$000F,$E000

 DC.W $000F,$E000,$007F,$FC00,$01E0,$7F00,$0380,$0F80	; plane 3
 DC.W $073E,$0AC0,$0CFF,$0560,$198F,$C2F0,$3347,$A0B8
 DC.W $32EB,$E158,$6647,$D0AC,$660B,$E05C,$4757,$D0AC
 DC.W $C7AF,$E05E,$A7FF,$D02E,$C1FF,$E05E,$A3FF,$202E
 DC.W $D17E,$C05E,$E0AB,$002E,$D014,$005E,$6800,$00AC
 DC.W $7000,$02DC,$7400,$057C,$2800,$0AF8,$3680,$55F8
 DC.W $1D54,$AAF0,$0EAB,$55E0,$0754,$ABC0,$03EB,$FF80
 DC.W $01FE,$FF00,$007F,$FC00,$000F,$E000

; Maske Bob
Ball_MASK:
 DC.W $000F,$E000,$007F,$FC00,$01FF,$FF00,$03FF,$FF80
 DC.W $07FF,$FFC0,$0FFF,$FFE0,$1FFF,$FFF0,$3FFF,$FFF8
 DC.W $3FFF,$FFF8,$7FFF,$FFFC,$7FFF,$FFFC,$7FFF,$FFFC
 DC.W $FFFF,$FFFE,$FFFF,$FFFE,$FFFF,$FFFE,$FFFF,$FFFE
 DC.W $FFFF,$FFFE,$FFFF,$FFFE,$FFFF,$FFFE,$7FFF,$FFFC
 DC.W $7FFF,$FFFC,$7FFF,$FFFC,$3FFF,$FFF8,$3FFF,$FFF8
 DC.W $1FFF,$FFF0,$0FFF,$FFE0,$07FF,$FFC0,$03FF,$FF80
 DC.W $01FF,$FF00,$007F,$FC00,$000F,$E000


;****************************************************************************

; Hintergrund 320 * 100 1 Bitplane, raw normal.

SfondoFinto:
	incbin	"/Sources/sfondo320x100.raw"

;****************************************************************************

	SECTION	bitplane,BSS_C
; Dies sind die Bitebenen des ersten Puffers
BITPLANE1:
	ds.b	40*256
BITPLANE2:
	ds.b	40*256
BITPLANE3:
	ds.b	40*256

; Dies sind die Bitebenen des zweiten Puffers
BITPLANE1b:
	ds.b	40*256
BITPLANE2b:
	ds.b	40*256
BITPLANE3b:
	ds.b	40*256

	end

;****************************************************************************

In diesem Beispiel lsen wir das Problem des Beispiels Listing10f1.s durch
die double buffering Technik. Diese Technik besteht in der Verwendung von
2 separaten Puffern. Einer der angezeigt wird und einer auf dem gezeichnet 
wird. Die Puffer werden bei jedem Vertical Blank ausgetauscht. Die Adressen
der 2 Puffer sind in 2 Variablen enthalten. Die Variable draw_buffer enthlt
die Adresse des Puffers, der zum Zeichnen verwendet wird. Die Routinen, die
den Bildschirm ndern (Bildschirm lschen und Objekt zeichnen) lesen die
Pufferadresse aus draw_buffer und fhren ihre Operationen darauf aus. Die
Variable view_buffer enthlt die aktuelle Pufferadresse die angezeigt wird.
Die ScambiaBuffer-Routine tauscht den Inhalt der 2 Variablen mit jedem 
vertical blank aus. Es stellt auch sicher, dass der richtige Puffer angezeigt
wird (der, dessen Adresse in view_buffer gespeichert ist). In der Tat, um
abwechselnd die 2 Puffer anzuzeigen, ist es erforderlich, bei jedem frame
die BPLxPT-Register die auf die Bitebenen des Anzeigepuffers zeigen in die
copperliste zu bringen. Dies bedeutet, dass die copperliste mit jedem vertical
blank modifiziert wird, was von der ScambiaBuffer-Routine erledigt wird.



 