
; Listing11g2.s -  Verwendung der Coppereigenschaft,  einen "MOVE"
				; durchzufhren erfordert horizontal 8 Pixel.
				; optimiert Rock'n Roll (im Original 52 Color0 Register)

	Section	coppuz,CODE

;	Include	"DaWorkBench.s"	; entferne das; vor dem Speichern mit "WO"

*****************************************************************************
	include	"/Sources/startup2.s"	; speichern Sie Interrupt, DMA und so weiter.
*****************************************************************************

; Mit DMASET entscheiden wir, welche DMA-Kanle geffnet und welche geschlossen werden sollen

			;5432109876543210
DMASET	EQU	%1000001010000000	; copper DMA aktivieren

WaitDisk	EQU	30				; 50-150 zur Rettung (je nach Fall)

START:
	BSR.W	MAKE_IT				; copperlist vorbereiten

	MOVE.W	#DMASET,$96(a5)		; DMACON - aktivieren copper								
	move.l	#COPLIST,$80(a5)	; Zeiger COP
	move.w	d0,$88(a5)			; Start COP
	move.w	#0,$1fc(a5)			; AGA deaktivieren
	move.w	#$c00,$106(a5)		; AGA deaktivieren
	move.w	#$11,$10c(a5)		; AGA deaktivieren
MOUSE:
	BTST	#$06,$BFE001		; Maus gedrckt?
	BNE.S	MOUSE
	RTS

*************************************************************************
* Diese Routine erstellt eine copperliste mit 45 COLOR0 Registern fr	*
* eine Zeile, also, da jeder move in der copperliste 8 Pixel (lowres)	*
* der auszufhrenden Zeit dauert, wird color0							*
* 45-mal HORIZONTAL in Schritten von 8 Pixeln gendert					*
*************************************************************************

;	  .:::::.
;	 ::::::
;	 |     |
;	C| _   _ l)
;	/ _(_)_ \
;	\_\_____/_/
;	 l_`---'_!
;	  `-----'xCz


LINSTART	EQU	$8031fffe		; ndern von "$80", um in einer
								; anderen vertikalen Zeile zu starten.
LINUM		EQU	25*3			; Anzahl der zu erledigenden Zeilen.

MAKE_IT:
	lea	CopBuf,a1				; Adressraum in copperlist
	move.l	#LINSTART,d0		; erstes "wait"
	move.w	#LINUM-1,d1			; Anzahl der zu erledigenden Zeilen
	move.w	#$180,d3			; Word fr Register color0 in copperlist
	move.l	#$01000000,d4		; Wert, der zum Wait zur nchsten Zeile
								; hinzugefgt werden soll.
colcon1:
	lea	cols(pc),a0				; Adresstabelle mit Farben in a0
	move.w	#45-1,d2			; 45 color pro Zeile	
	
	move.l	d0,(a1)+			; Setzen des WAIT in der copperlist
colcon2:
	move.w	d3,(a1)+			; Setzen des Registers COLOR0 ($180)
	move.w	(a0)+,(a1)+			; Setze den Wert von COLOR0 (aus der Tabelle)
	dbra	d2,colcon2			; Fhre eine ganze Zeile aus
	add.l	d4,d0				; "WAIT" machen eine Zeile darunter (+$01000000)
	dbra	d1,colcon1			; Wiederholen Sie dies fr die Anzahl
	rts							; der zu erledigenden Zeilen


; Tabelle mit den 45 Farben einer horizontalen Zeile.

cols:
	dc.w	$2AB,$2BA,$2C9,$2D8,$2E7,$2F6,$4E7,$6D8,$8C9,$ABA
	dc.w	$CAA,$D9A,$E8A,$F7A,$F6B,$F5C,$D6D,$B6E,$96F,$76F
	dc.w	$56F,$36F,$26F,$27E,$28D,$29C,$2AB,$2BA,$2C9,$2D8
	dc.w	$2E7,$2F6,$4E7,$6D8,$8C9,$ABA,$CAA,$D9A,$E8A,$F7A
	dc.w	$F6B,$F5C,$D6D,$B6E,$96F

*****************************************************************************

	section	coppa,data_C

COPLIST:
	DC.W	$100,$200			; BplCon0 - keine bitplanes
	DC.W	$180,$003			; Color0 - blau
CopBuf:
	dcb.w	(45*2)*LINUM+(2*linum),0	; Platz fr die copperlist.
	DC.W	$180,$003			; Color0 - blau
	dc.w	$ffff,$fffe			; Ende copperlist

	END

In diesem Fall haben wir den Effekt "bunter" gemacht, nichts Besonderes.
 