		************************************
		*       /\/\                       *
		*      /    \                      *
		*     / /\/\ \ O R B_I D           *
		*    / /    \ \   / /              *
		*   / /    __\ \ / /               *
		*        \ \/ / I S I O N S    *
		*           \ \/ /                 *
		*            \  /                  *
		*             \/                   *
		*     Feel the DEATH inside!       *
		************************************
		* Coded by:                        *
		* The Dark Coder / Morbid Visions  *
		************************************

; Listing17a.s = mask1.s

* ACHTUNG:
; Diese Quelle basiert auf Listing11h4.s von Randys-Kurs.
; es zeigt die Maskierung auch fr vertikale Positionen
; grer als $80. Kommentare am Ende der Quelle
; die Originalquelle stammt von Randy - RJ
; Hey Randy, ich hoffe, es macht dir nichts aus, wenn ich deine Arbeit verbessere!
; Friendship RULEZ! :)))) (The Dark Coder)
 
	SECTION	DK,code
	;incdir	"/include/"			; wenn in einem Verzeichnis ein Ordner include
								; und in einem anderen Ordner die Quelle ist
								; (also zuerst eine Pfadebene hher gehen)
	;incdir	"include/"			; wenn in einem Verzeichnis ein Ordner include
	incdir "/Sources/include/"	; und im selben Verzeichnis die Quelle ist 
	include	"MVstartup.s"		; Startup Code: Nimmt
								; Systemprfung vor und Aufruf
								; durch Platzieren der START-Routine: 
								; A5=$DFF000

			;5432109876543210
DMASET	EQU	%1000001010000000		; nur copper DMA

Start:
	lea	$dff000,a5
	move	#DMASET,dmacon(a5)		; DMACON - aktivieren copper
								

	move.l	#COPPERLIST,cop1lc(a5)	; Zeiger COP
	move	d0,copjmp1(a5)			; Start COP

mouse:

; Beachten Sie die doppelte berprfung der Synchronitt
; notwendig, da der Copper-Move weniger als EINE Rasterzeile auf 68030 bentigt
	move.l	#$1ff00,d1			; Bits durch UND auswhlen
	move.l	#$13000,d2			; warte auf Zeile $130 (304)
.waity1
	move.l	vposr(a5),d0		; vposr und vhposr
	and.l	d1,d0				; whlen Sie nur die Bits der vertikalen Pos.
	cmp.l	d2,d0				; warte auf Zeile $130 (304)
	bne.s	.waity1

.waity2
	move.l	vposr(a5),d0
	and.l	d1,d0
	cmp.l	d2,d0
	beq.s	.waity2

	btst	#2,potinp(a5)		; rechte Maustaste gedrckt?
	beq.s	.noMuovi			; wenn ja fhre MuoviCopper nicht aus
	bsr.s	MuoviCopper			; Routine, die die WAIT-Maskierung nutzt
.noMuovi

	btst	#6,$bfe001			; Maus gedrckt?
	bne.s	mouse
	rts

*****************************************************************************

MuoviCopper:
	tst.b	SuGiu				; Sollen wir rauf oder runter gehen? wenn SuGiu
								; gelscht ist (d.h. der TST berprft den BEQ)
								; dann springen wir zu VAIGIU, wenn es stattdessen $FF ist
								; (wenn dieser TST nicht verifiziert ist)
								; wir steigen weiter auf (machen subqs)
	beq.w	VAIGIU
	cmp.b	#$80,BARRA			; Haben wir die Zeile $80 erreicht?
	sne	SuGiu					; Wenn ja, sind wir oben und mssen runter
								; In Randys Code war ein springender Beq
								; zu einem Code, der das Flag lschte.
								; Mit dem SCC geht es schneller und spart
								; Speicher. Es ist ratsam immer Scc
								; zu verwenden, um die Flags zu ndern
	subq.b	#1,BARRA
	rts

VAIGIU:
	cmp.b	#$F0,BARRA			; Haben wir die Zeile $F0 erreicht?
	seq	SuGiu					; Wenn ja, sind wir ganz unten und mssen wieder hoch
								; Auch hier haben wir das BEQ durch ein SEQ ersetzt
								
	addq.b	#1,BARRA
	rts

SuGiu:	dc.b	0				; Richtungs-Flag
								; $00 - runter, $FF - rauf

*****************************************************************************

	SECTION	GRAPHIC,DATA_C

COPPERLIST:
	dc.w	$100,$200
	dc.w	$180,$000			; Anfangsfarbe copper Farbe SCHWARZ

	dc.w	$2c07,$FFFE			; eine kleine grne Bar
	dc.w	$180,$010
	dc.w	$2d07,$FFFE
	dc.w	$180,$020
	dc.w	$2e07,$FFFE
	dc.w	$180,$030
	dc.w	$2f07,$FFFE
	dc.w	$180,$040
	dc.w	$3007,$FFFE
	dc.w	$180,$030
	dc.w	$3107,$FFFE
	dc.w	$180,$020
	dc.w	$3207,$FFFE
	dc.w	$180,$010
	dc.w	$3307,$FFFE
	dc.w	$180,$000


BARRA:
	dc.w	$8407,$FFFE			; warte auf Zeile $84 (WAIT NORMAL!)
								; Dieses Wait ist der "Chef" des Wartens
								; maskierte folgen, tatschlich folgen sie ihm
								; wie Handlanger: wenn das warten
								; um 1 sinkt, werden alle Waits maskiert
								; nach unten gehen um 1 usw.

	dc.w	$180,$300			; Ich starte den roten Balken: rot mit 3

	dc.w	$80E1,$80FE			; Dieses WAIT wartet auf das Ende einer Zeile.
								; Dies ist ein Wait mit vertikal maskierter Position
								; Weil die Anweisung NACH der Zeile $80 ausgefhrt
								; werden muss, das hohe Bit (nicht maskierbar)
								; muss auf 1 gesetzt werden.

	dc.w	$0001,$FFFE			; Dieses WAIT ist eine "nutzlose" Anweisung
								; Tatschlich blockiert es niemals den copper.
								; Ihr Zweck ist es einige Zeit fr den copper
								; zu verlieren, damit der folgende CMOVE ausgefhrt
								; wird, wenn der Elektronenstrahl die
								; nchste Zeile startet.

	dc.w	$180,$600			; rot mit 6

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$900			; rot mit 9

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$c00			; rot mit 12

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$f00			; rot mit 15 (maximal)

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$c00			; rot mit 12

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$900			; rot mit 9

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$600			; rot mit 6

	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$300			; rot mit 3

UltimaFineRiga:
	dc.w	$80E1,$80FE			; auf das Zeilenende warten
	dc.w	$0001,$FFFE			; nutzloses WAIT das den Copper verlangsamt

	dc.w	$180,$000			; color schwarz

	dc.w	$fd07,$FFFE			; warten auf Zeile $FD
	dc.w	$180,$00a			; blaue Intensitt 10
	dc.w	$fe07,$FFFE			; nchste Zeile
	dc.w	$180,$00f			; blaue Intensitt maximal (15)

	dc.w	$FFFF,$FFFE			; ENDE COPPERLIST

	end

Randys Kurs zeigt in Listing11h4.s, wie man eine Bar mit dem Copper durch
WAITs mit maskierter vertikaler Position macht.
Die Technik, mit der Sie die Aktualisierung der verglichenen Copperliste
beschleunigen knnen wenn WAIT mit NICHT maskierten vertikalen Positionen
verwendet wird.
In der Quelle wird auch die Unmglichkeit behauptet, diese Technik anzuwenden
in vertikalen Positionen zwischen $80 und $FF. Wir zitieren direkt aus dem
Vortragskommentar 11h4.s:

"Man kann also sagen, dass die Maskierung im oberen Teil des Bildschirm von
$00 bis $7f und unterhalb der NTSC-Zone, dh nach dem $FFDF,$FFFE arbeitet."

Nun das ist falsch !!!
Wie wir auch im Artikel "More Advanced Copper" dazu erlutert haben, ist es
durchaus mglich, eine Maskierung an Positionen zwischen $80 und $FF mit einem
sehr einfachen Trick zu verwenden. In der Tat ergibt sich das Problem aus der
Tatsache, dass das hchste Bit der vertikalen Position des coppers nicht
maskierbar ist und daher, dass die Position die in WAIT (oder SKIP) angegeben
ist und die Elektronen-Strahlenposition vom copper zum Vergleich nicht
verwendet wird.
Randy verwendet in der Quelle Listing11h4.s seines Kurses WAITs mit den 
7 maskierten Low-Bits der vertikalen Position, um auf das Ende einer Zeile
zu warten. Die WAITs, die Randy verwendet, sind DC.W $00E1,$80FE, die das
Bit 8 der zu wartenden vertikalen Position (d.h. Bit 15 des ersten WORTES)
auf 0 setzen.
Wenn ein solches WAIT durchgefhrt wird, wenn sich der Elektronenstrahl
an einer vertikalen Position befindet, wobei Bit 8 auf 0 gesetzt ist (d.h.
weniger als $80 oder grer als $FF), wobei die 8 Bits den gleichen Wert
haben und wenn die anderen Bits der vertikalen Position deaktiviert sind,
wird die horizontale Position bercksichtigt, und daher wartet das WAIT wie
gewnscht auf das Zeilenende.
Wenn stattdessen ein solches WAIT durchgefhrt wird, wenn sich der
Elektronenstrahl an einer vertikalen Position befindet, wobei Bit 8 auf 1
gesetzt ist (d.h. grer als oder gleich $80 und kleiner als oder gleich $FF),
wobei Bit 8 der vertikalen Position des Elektronenstrahls grer als Bit 8
der in angegebenen Wait-Position, dann betrachtet der copper die von WAIT
angegebene Position als geringer als der Elektronenstrahl und wartet NICHT
auf das Ende der Zeile.
Wie warten Sie dann auf das Ende einer Zeile, deren vertikale Position das
Bit 8 auf 1 gesetzt hat? Es ist sehr einfach, WAIT wie folgt zu verwenden:

  DC.W $80E1,$80FE

Dieses WAIT unterscheidet sich von dem von Randy verwendeten, weil es Bit 8 der 
vertikalen Position auf 1 gesetzt hat. Auf diese Weise, wenn es getan wird,
wenn der Elektronenstrahl sich in vertikaler Position befindet, wobei Bit 8
gesetzt ist bis 1 sind die gleichwertigen Bits 8 und da die anderen Bits der
vertikalen Position deaktiviert sind, wird die horizontale Position
bercksichtigt, und daher wartet WAIT wie gewnscht auf das Zeilenende.

Mit WAIT diesen Typs knnen wir die beschriebene Technik anwenden, um in der
Quelle Lezione11h4.s, den Balken in den Zeilen zwischen  $80 und $FF zu
verschieben. Beachten Sie jedoch, dass WAITs diesen Typs NICHT in Zeilen
funktionieren bei denen Bit 8 der vertikalen Position auf 0 gesetzt sind.

In der Tat, wenn die Ausfhrung in diesen Zeilen stattfindet, wo das Bit 8 der
vertikalen Position des Elektronenstrahls kleiner als die mit Bit 8 im Wait
angegebene Position ist, betrachtet der Copper die Position im wait als grer,
als die des Elektronenstrahls und darum wartet er beim Wait (blockiert den
Wait) bis der Elektronenstrahl die Zeile erreicht, wo Bit 8 auf 1 ist ($80
 oder die Copperliste startet wieder von vorn.

Es erreicht eine Zeile mit Bit 8 auf 1 ($80) oder die copperliste wird nicht
von Anfang an neu gestartet. Mit den in dieser Quelle verwendeten WAITs knnen
wir also die Bewegung des Balkens NUR in Zeilen zwischen $80 und $FF ausfhren.
Sehen heit glauben.

Wie bewegen wir dann eine Bar ber den gesamten Bildschirm?
Wir werden dies im Beispiel "mask2.s" sehen. In der Zwischenzeit mchte ich
darauf hinweisen, dass wir in unserer copperliste einen weiteren Unterschied zu
der Quelle von Randy haben. Tatschlich verwendet Randy ein paar WAITs:

	dc.w	$00E1,$80FE	; AUF DIE NCHSTE ZEILE WARTEN
	dc.w	$0007,$80FE	; MIT dem "maskierten" Wait bei Y

Das erste WAIT wartet auf das Ende einer Zeile. Aber wie Sie wissen beginnt
physisch eine Linie ber den Bildschirm, wenn der Copper bereits die 
Position $7 erreicht hat. Wenn sich nach dem ersten WARTEN sofort das Copper
Move COLOR00 ndert, wrden Sie die Farbnderung am rechten Bildschirmrand
sehen (wieder sehen ist glauben). Hierzu ist das zweite WAIT erforderlich.
Warten Sie auf die Position $7. Beachten Sie jedoch, dass der Copper eine
kurze Zeit bentigt um von Position $E1 zu Position $7 der folgenden Zeile
zu gelangen. Deshalb, um den unerwnschten Effekt zu vermeiden, kann auch eine
andere Lsung gewhlt werden:
Zwischen dem Warten auf das Ende der Zeile und dem CMOVE, das COLOR00 ndert,
setzen sie eine copperanweisung, die nichts bewirkt, zum Beispiel WAIT (NOT
maskiert), die auf Position 0,0 wartet und daher immer bergeben wird.
Selbst wenn die Anweisung unbrauchbar ist, muss das copper einige Zeit
verschwenden, um es zu betreiben, und diese Zeitverschwendung ist genug.
Whrenddessen erreicht der Elektronenstrahl die Position $7, dann wird der
CMOVE COLOR00 in einer solchen Position ausgefhrt, dass der Farbwechsel am
rechten Rand ist. In diesem Beispiel haben wir diese Technik bernommen, also
setzen wir anstelle von Randys DC.W $0007,$80FE einige einfache und NICHT
maskiertee WAITs in Zeile 0, dh DC.W $0001,$FFFE ein.
Warum haben wir das gemacht? Das erfahren Sie im Beispiel "mask2.s" !!!!
