
; Listing25a2.s		ANZEIGEN EINES SPRITE mit wait und SPRxPOS
;					mit Copper-Move		("halbautomatischer Modus")
;					und erneutes Anzeigen ber automatisches Modus					

	SECTION R'nR,CODE

Anfang:
	move.l	4.w,a6			; Execbase
	jsr	-$78(a6)			; Disable
	lea	GfxName(PC),a1		; Libname
	jsr	-$198(a6)			; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop	; wir speichern die alte COP

	; Pointen auf das "leere" Bild

	MOVE.L	#BITPLANE,d0	; Adresse der Bitplane
	LEA	BPLPOINTERS,A1		; Bitplanepointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	
;-------------------------------
initcopper:
	move.l	#$2c01fffe,d0		; 1. wait			
	move.l	#$01402c40,d1		; SPR0POS V=$2c, H=$40 
	move.l	#$01423900,d2		; SPR0CTL V=$39, H=0	$2c+13=$39

	MOVE.L	#MEINSPRITE+4,d4	; Adresse des Sprite in d0 auf Spritedaten!
								; nicht auf die Steuerwrter!		
	lea	coppersprite,a0			; Adresse copperlist 
	move.l	d0,(a0)+			; setzt das erste wait	
;---------------
; Spritepointer setzen in Copperlist
	move.w	#$0120,(a0)+		; SPR0PTH
	swap d4	
	move.w	d4,(a0)+			; hi-Anteil Adresse eintragen
	move.w  #$0122,(a0)+		; SPR0PTL
	swap d4			
	move.w	d4,(a0)+			; low-Anteil Adresse eintragen
;----------------
    move.l	d1,(a0)+			; SPR0POS
	move.l	d2,(a0)+			; SPR0CTL
;----------------
; Spritepointer nach Anzeigen des ersten Sprites neu zurcksetzen
	move.l	#$3a01fffe,(a0)+	; nach Zeile $39 und vor Beginn Zeile $60
	move.w	#$0120,(a0)+		; SPR0PTH
	swap d4	
	move.w	d4,(a0)+			; hi-Anteil Adresse eintragen
	move.w  #$0122,(a0)+		; SPR0PTL
	swap d4			
	move.w	d4,(a0)+			; low-Anteil Adresse eintragen

	move.l	#$fffffffe,a0		; Ende der Copperlist
;-------------------------------

	move.l	#COPPERLIST,$dff080	; unsere COP
	move.w	d0,$dff088		; START COP
	move.w	#0,$dff1fc		; NO AGA!
	move.w	#$c00,$dff106	; NO AGA!

mouse:
	btst	#6,$bfe001		; Maustaste gedrckt?
	bne.s	mouse

	move.l	OldCop(PC),$dff080	; Pointen auf die alte SystemCopperlist
	move.w	d0,$dff088		; Starten die alte SystemCopperlist

	move.l	4.w,a6
	jsr	-$7e(a6)			; Enable
	move.l	gfxbase(PC),a1
	jsr	-$19e(a6)			; Closelibrary
	rts

;	Daten

GfxName:
	dc.b	"graphics.library",0,0

GfxBase:
	dc.l	0

OldCop:
	dc.l	0


	SECTION GRAPHIC,DATA_C

COPPERLIST:
SpritePointers:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

	dc.w	$8e,$2c81		; DiwStrt
	dc.w	$90,$2cc1		; DiwStop
	dc.w	$92,$38			; DdfStart
	dc.w	$94,$d0			; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod

				; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres

BPLPOINTERS:
	dc.w	$e0,0,$e2,0		; erste Bitplane

	dc.w	$180,$000		; color0	; Hintergrund Schwarz
	dc.w	$182,$123		; color1	; Farbe 1 der Bitplane, die
							; in diesem Fall leer ist,
							; und deswegen nicht erscheint

	dc.w	$1A2,$F00		; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0		; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0		; Color19, oder COLOR3 des Sprite0 - GELB

coppersprite:
	blk.l	10,$fffffffe 

	dc.w	$FFFF,$FFFE		; Ende der Copperlist


; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:		; Lnge 13 Zeilen
VSTART:
	dc.b $60	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $D0	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $6d	; $60+13=$6d - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 ;dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.
 dc.w	$6040,$6d00

	SECTION LEERESPLANE,BSS_C	; Eine auf 0 gesetzte Bitplane, wir
							; mssen es verwenden, denn ohne Bitplane
							; ist es nicht mglich, die Sprites
							; zu aktivieren
BITPLANE:
	ds.b	40*256			; Bitplane auf 0 Lowres

	end


Erklrung:

Bei diesem Beispiel ist das Ende des Sprites nicht mit dc.w 0,0 sondern mit
dc.w	$6040,$6d00 definiert. Nach dem Ende des Sprites welches durch
SPR0CTL = 3900 definiert wurde, wird automatisch das nchste Datenpaar 
abgerufen und als Steuerwrter interpretiert. 
Das neue Paar ist: $6040,$6d00. Jetzt mssen nur vor Beginn der Zeile $60
und nach dem Ende des ersten Sprites die Spritepointer zurckgesetzt werden
und dann startet das Sprite an Position $6040 erneut.
Auch nach diesem Ende werden wieder als letztes die Steuerwrter neu geholt
und interpretiert. Bei diesem Vergleich liegen die Positionsdaten aber nun
bereits hinter der aktuellen Elektronenstrahlposition und das Sprite data
fetch endet damit.

