
; Listing25c2.s		horizontales Spritemultiplexing mit wait und SPRxPOS
;                   ber die gesamte Bildschirmzeile
;					mit Copper-Move		("halbautomatischer Modus")

spritekanal = 0				; 0 - SPR0 , 1 - SPR1 .... , 7 - SPR7

	SECTION CipundCop,CODE

Anfang:
	move.l	4.w,a6			; Execbase
	jsr	-$78(a6)			; Disable
	lea	GfxName(PC),a1		; Libname
	jsr	-$198(a6)			; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop	; wir speichern die alte COP

	; Pointen auf das "leere" Bild

	MOVE.L	#BITPLANE,d0	; Adresse der Bitplane
	LEA	BPLPOINTERS,A1		; Bitplanepointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	; Pointen auf den Sprite

	move.l	#MEINSPRITE,d0	; Adresse des Sprite in d0
	lea	SpritePointers,a1	; Pointer in der Copperlist
	; zum Test die Spritekanalnummer ndern
	lea spritekanal*8(a1),a1		; lea Spritekanal*8(a1),a1
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

;-------------------------------	
; Copper-Sprites bentigen: 
; 13*wait
; 13*23 SPR0POS
; 13*23 COP-NOP
; = 13+299+2299=611.l

; andere Spritekanle testen:	
	moveq  #spritekanal*8,d6		
	swap d6

initcopper:
	move.l	#$1a29fffe,d0			; wait
	move.l  #$01401a30,d1			; SPR0POS Start
	add.l   d6,d1					; Spritekanal			
	move.l  #$01fe0000,d2			; COP-NOP

	lea coppersprite,a0
	moveq #13-1,d4					; 13 Zeilen		
zeile:
	moveq #23-1,d3					; 22 Anzahl Sprites horizontal nebeneinander
	move.l	d0,(a0)+				; wait
hor:	
	move.l	d1,(a0)+				; SPR0POS V=$1a, H=$40+8*n
	cmp.b	#0,d3
	move.l  d2,(a0)+				; Copper-NOP	
	add.b	#8,d1					; nchste horizontale Position	
	dbf d3,hor
	add.l #$01000000,d0				; nchste Zeile
	move.b  #$30,d1					; SPR0POS zurcksetzen
	dbf d4,zeile
;-------------------------------

	move.l	#COPPERLIST,$dff080	; unsere COP
	move.w	d0,$dff088		; START COP
	move.w	#0,$dff1fc		; NO AGA!
	move.w	#$c00,$dff106	; NO AGA!

mouse:
	btst	#6,$bfe001		; Maustaste gedrckt?
	bne.s	mouse

	move.l	OldCop(PC),$dff080	; Pointen auf die alte SystemCopperlist
	move.w	d0,$dff088		; Starten die alte SystemCopperlist

	move.l	4.w,a6
	jsr	-$7e(a6)			; Enable
	move.l	gfxbase(PC),a1
	jsr	-$19e(a6)			; Closelibrary
	rts

;	Daten

GfxName:
	dc.b	"graphics.library",0,0


GfxBase:
	dc.l	0

OldCop:
	dc.l	0


	SECTION GRAPHIC,DATA_C

COPPERLIST:
SpritePointers:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

	dc.w	$8e,$1a5c		; DiwStrt
	dc.w	$90,$80d4		; DiwStop
	dc.w	$92,$20			; DdfStart
	dc.w	$94,$d8			; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod

				; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres

BPLPOINTERS:
	dc.w	$e0,0,$e2,0		; erste Bitplane

	dc.w	$180,$000		; color0	; Hintergrund Schwarz
	dc.w	$182,$123		; color1	; Farbe 1 der Bitplane, die
							; in diesem Fall leer ist,
							; und deswegen nicht erscheint

	dc.w	$1A2,$F00		; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0		; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0		; Color19, oder COLOR3 des Sprite0 - GELB

coppersprite:
	blk.l	611,$0	
	dc.w	$FFFF,$FFFE		; Ende der Copperlist


; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:		; Lnge 13 Zeilen
VSTART:
	dc.b $1a	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $00	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $27	; $1a+13=$27 - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.


	SECTION LEERESPLANE,BSS_C	; Eine auf 0 gesetzte Bitplane, wir
							; mssen es verwenden, denn ohne Bitplane
							; ist es nicht mglich, die Sprites
							; zu aktivieren
BITPLANE:
	ds.b	40*256			; Bitplane auf 0 Lowres

	end



Erklrung:

In diesem Beispiel demonstrieren wir das horizontale Spritemultiplexing ber
den gesamten Bildschirm. Der Screen ist im Overscan eingestellt. Nur fr den
Spritekanal 0 und 1 ist dies mglich. Fr andere Spritekanle verlieren wir
aufgrund des frher eingestellten DDFSTRT Sprite-DMA-Slots durch Bitplane 
DMA. Und es gibt zustzliche Effekte mit "zerstrten" Sprites.

1.
Um andere Spritekanle zu testen, die Variable 'spritekanal' am anfang des
Programms einstellen: Es ndert das Programm an zwei Stellen:

lea spritekanal*8(a1),a1  ; beim Pointen auf den Sprite anpassen und

SPR0POS = $140
SPR1POS = $148
SPR2POS = $150
SPR3POS = $158
...
SPR7POS = $178

und
	move.l  #$01401a30,d1			; SPR0POS Start
	add.l   d6,d1					; Spritekanal

2. 
In dieser Anordnung wird der letzte Sprite richtig angezeigt auch wenn die
Copper-Move Befehle nicht fr alle Zeilen des Sprites durchgefhrt werden.
z.B.

ndern:
	moveq #1-1,d4		; nur 1 Zeilen
	moveq #23-1,d3		; 22 Anzahl Sprites horizontal nebeneinander

Das liegt daran, weil die Steuerwrter danach nicht mehr gendert werden und
die Hardware es dadurch wie ein "normales" Sprite anzeigt.
