
; Listing25d2.s		horizontales Spritemultiplexing mit wait und SPRxPOS
;                   mit Copperloop

	SECTION R'nR,CODE

Anfang:
	move.l	4.w,a6			; Execbase
	jsr	-$78(a6)			; Disable
	lea	GfxName(PC),a1		; Libname
	jsr	-$198(a6)			; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop	; wir speichern die alte COP

	; Pointen auf das "leere" Bild

	MOVE.L	#BITPLANE,d0	; Adresse der Bitplane
	LEA	BPLPOINTERS,A1		; Bitplanepointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	; Pointen auf den Sprite

	move.l	#MEINSPRITE,d0		; Adresse des Sprite in d0
	move.l	#MEINSPRITE+4,d1	; Adresse des Sprite in d0
	
	lea	SpritePointers,a1	; Pointer in der Copperlist
	move.w	d0,6(a1)
	move.w	d1,sprpt+2		; Spritepointer zurcksetzen
	swap	d0
	move.w	d0,2(a1)
		
	move.l	#copperloop1,d0
	move	d0,cpptr1+6
	swap	d0
	move	d0,cpptr1+2

	move.l	#copperloop2,d0
	move	d0,cpptr2+6
	swap	d0
	move	d0,cpptr2+2

	move.l	#COPPERLIST,$dff080	; unsere COP
	move.w	d0,$dff088		; START COP
	move.w	#0,$dff1fc		; NO AGA!
	move.w	#$c00,$dff106	; NO AGA!

mouse:
	btst	#6,$bfe001		; Maustaste gedrckt?
	bne.s	mouse

	move.l	OldCop(PC),$dff080	; Pointen auf die alte SystemCopperlist
	move.w	d0,$dff088		; Starten die alte SystemCopperlist

	move.l	4.w,a6
	jsr	-$7e(a6)			; Enable
	move.l	gfxbase(PC),a1
	jsr	-$19e(a6)			; Closelibrary
	rts

;	Daten

GfxName:
	dc.b	"graphics.library",0,0
	
GfxBase:
	dc.l	0

OldCop:
	dc.l	0


	SECTION GRAPHIC,DATA_C

COPPERLIST:
SpritePointers:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

	dc.w	$8e,$1a5c		; DiwStrt
	dc.w	$90,$1ad4		; DiwStop
	dc.w	$92,$20			; DdfStart
	dc.w	$94,$d8			; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod

				; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres

BPLPOINTERS:
	dc.w	$e0,0,$e2,0		; erste Bitplane

	dc.w	$180,$000		; color0	; Hintergrund Schwarz
	dc.w	$182,$123		; color1	; Farbe 1 der Bitplane, die
							; in diesem Fall leer ist,
							; und deswegen nicht erscheint

	dc.w	$1A2,$F00		; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0		; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0		; Color19, oder COLOR3 des Sprite0 - GELB
	
cpptr1
	dc.w	$084,0
	dc.w	$086,0
	
	dc.w	$8001,$fffe		; wait, wo die Sprite beginnen sollen
copperloop1:
	dc.w	$0140,$0040		; SPR0POS Start	

	dc.w	$8041,$80fe
	dc.w	$0140,$0060		; SPR0POS Start	
	
	dc.w	$8061,$80fe
	dc.w	$0140,$0080		; SPR0POS Start	
	
	dc.w	$8081,$80fe
	dc.w	$0140,$00a0		; SPR0POS Start	
	
	dc.w	$80a1,$80fe
	dc.w	$0140,$00c0		; SPR0POS Start	
		
	dc.w	$80e1,$80fe		; warte auf Ende der Zeile			

	dc.w	$8ce1,$ffff     ; skip loop wenn Spriteende erreicht ist                                                          
	dc.w	$8a,$0
;-------------------------------------------------
sprpt:	
	dc.w	$0122,0			; Spritepointer zurcksetzen

	dc.w	$0140,$8e40		; SPR0POS Start 
	dc.w	$0142,$9b00		; SPR0CTL Start
cpptr2
	dc.w	$084,0
	dc.w	$086,0
copperloop2:
	dc.w	$0140,$0040		; SPR0POS Start	

	dc.w	$8d41,$80fe
	dc.w	$0140,$0060		; SPR0POS Start	
	
	dc.w	$8d61,$80fe
	dc.w	$0140,$0080		; SPR0POS Start	
	
	dc.w	$8d81,$80fe
	dc.w	$0140,$00a0		; SPR0POS Start	
	
	dc.w	$8da1,$80fe
	dc.w	$0140,$00c0		; SPR0POS Start	
		
	dc.w	$8de1,$80fe		; warte auf Ende der Zeile			

	dc.w	$9ae1,$ffff     ; skip loop for lines >=$fe                                                          
	dc.w	$8a,$0

	dc.w	$FFFF,$FFFE		; Ende der Copperlist


; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:		; Lnge 13 Zeilen
VSTART:
	dc.b $80	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $00	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $9a	; $1a+13=$27 - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.


	SECTION LEERESPLANE,BSS_C	; Eine auf 0 gesetzte Bitplane, wir
							; mssen es verwenden, denn ohne Bitplane
							; ist es nicht mglich, die Sprites
							; zu aktivieren
BITPLANE:
	ds.b	40*256			; Bitplane auf 0 Lowres

	end
	
Erklrung:

Hier sehen wir horizontales und vertikales Spritemultiplexing mit Copperloop.

>?$80+!13
$0000008D = %00000000`00000000`00000000`10001101 = 141 = 141
>?$80+!13+!13
$0000009A = %00000000`00000000`00000000`10011010 = 154 = 154
>

Das Sprite ist 13 Zeilen hoch. Wir geben jedoch die doppelte Hhe an, weil wir
das Sprite vertikal sofort wiederholen wollen. Sprite-DMA wird dadurch erst 
nach der Anzeige des wiederholten Sprites beendet. Vor der Anzeige des zu
wiederholenden Sprites muss nur der Spritepointer auf den Beginn der Bilddaten
zurckgesetzt werden.

Ansonsten erfolgt die Anzeige durch zwei Copperschleifen.
Die erste im Bereich von $80 bis $8c und die zweite von $8D bis $9a.
